﻿
Imports System.Net


Public Class frmKinectConfigure

    Private Sub frmKinectConfigure_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        On Error Resume Next
        Me.Visible = True
        updnOffsetX.Value = tmcScanVectorOffset.X
        updnOffsetY.Value = tmcScanVectorOffset.Y
        sliderKinectRangeCalibrate.Value = sngKinectCalibrate * 100
        sliderKinectDepthCurveAdjust.Value = (sngKinectCurveAdjust + 1) * 100
        chkContinuous.Checked = False
    End Sub

    Private Sub updnOffsetX_ValueChanged(sender As Object, e As EventArgs) Handles updnOffsetX.ValueChanged
        On Error Resume Next
        If updnOffsetX.ContainsFocus Then
            tmcScanVectorOffset.X = updnOffsetX.Value
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub updnOffsetY_ValueChanged(sender As Object, e As EventArgs) Handles updnOffsetY.ValueChanged
        On Error Resume Next
        If updnOffsetY.ContainsFocus Then
            tmcScanVectorOffset.Y = updnOffsetY.Value
            boolSettingsChanged = True
        End If
    End Sub

    Private Sub trbRangeCalibrate_Scroll(sender As Object, e As EventArgs) Handles sliderKinectRangeCalibrate.Scroll
        On Error Resume Next
        sngKinectCalibrate = sliderKinectRangeCalibrate.Value / 100
        boolSettingsChanged = True
        subCalculateKinectCoefficients()
    End Sub



    Private Sub chkContinuous_CheckedChanged(sender As Object, e As EventArgs) Handles chkContinuous.Click
        On Error Resume Next
        If chkContinuous.ContainsFocus Then
            Me.Refresh()
            While chkContinuous.Checked And Me.Visible And Not boolShutDown
                subDoEventsIfMainThread()
                boolRangeReadingsAreFresh = False
                frmRangeFinder.subGetRangerReadings()
                evntVectorsAreFresh.WaitOne(1000) ' wait for fresh Kinect data
                GotABotClass.subRedraw(tbpBotPose)
                subDrawScanVectors(tbpBotPose, True)
            End While
            If Not Me.Visible Then chkContinuous.Checked = False
            GotABotClass.subRedraw(tbpBotPose)
        End If
    End Sub

    Private Sub sliderKinectDepthCurveAdjust_Scroll(sender As Object, e As EventArgs) Handles sliderKinectDepthCurveAdjust.Scroll
        On Error Resume Next
        If sliderKinectDepthCurveAdjust.ContainsFocus Then
            sngKinectCurveAdjust = sliderKinectDepthCurveAdjust.Value / 100 - 1
            boolSettingsChanged = True
            subCalculateKinectCoefficients()
        End If
    End Sub

    Private Sub Cancel_Button_Click(sender As Object, e As EventArgs) Handles Cancel_Button.Click
        On Error Resume Next
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Dim tbpTempPose As typeBotPose = tbpBotPose ' make sure we aren't throwing away important stuff!
        Dim tlmTempLandMarkArray(128) As typeLandMark
        tlmTempLandMarkArray = tlmLandMarkArray
        GotABotClass.mnuLoadSettings_Click(trfRangeFinders, e)
        tbpBotPose = tbpTempPose
        tlmLandMarkArray = tlmTempLandMarkArray
        strStatusDriving = ""
        GotABotClass.subRedraw(tbpBotPose)
        Me.Close()
    End Sub

    Private Sub OK_Button_Click(sender As Object, e As EventArgs) Handles OK_Button.Click
        On Error Resume Next
        Me.Visible = False
        On Error Resume Next
        strStatusDriving = ""
        GotABotClass.subRedraw(tbpBotPose)
        subCalculateKinectBeamAngles()
        subCalculateKinectCoefficients()
        Me.Close()
    End Sub

    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
        On Error Resume Next
        System.GC.Collect()
    End Sub


    Delegate Sub DelegateUpdateLabel(ByVal strNewText As String, ByVal colText As Color)
    Public Sub subUpdateStatusLabel1(ByVal strNewText As String, ByVal colText As Color)
        On Error Resume Next
        If InvokeRequired And Not boolShutDown Then
            Dim newDelegate As New DelegateUpdateLabel(AddressOf subUpdateStatusLabel1)
            Invoke(newDelegate, New Object() {strNewText, colText})
            System.Windows.Forms.Application.DoEvents()
        ElseIf Not boolShutDown Then
            tsslKinectStatus.ForeColor = colText
            tsslKinectStatus.Text = strNewText
        End If ' GotABotClass.InvokeRequired
    End Sub

    '--------------------------------------  MENU BAR   -----------------------------------------------------

    Private Sub mnuDefaultElevation_Click(sender As Object, e As EventArgs) Handles mnuDefaultElevation.Click
        On Error Resume Next
        Dim strDefaultElevation As String
        strDefaultElevation = InputBox("Enter Default Elevation Angle (-27 to 27 degrees) ", "Elevation Angle", Str(intDefaultElevation))
        If strDefaultElevation <> "" And IsNumeric(strDefaultElevation) Then
            intDefaultElevation = Convert.ToInt16(strDefaultElevation)
            If (intDefaultElevation < -27) Then intDefaultElevation = -27
            If (intDefaultElevation > 27) Then intDefaultElevation = 27
            K_Sensor.ElevationAngle() = intDefaultElevation
            boolSettingsChanged = True
        End If
        Me.Refresh()
        System.Windows.Forms.Application.DoEvents()
    End Sub

    'Private Sub mnuBeams_Click(sender As Object, e As EventArgs) Handles mnuBeams.Click
    '    On Error Resume Next
    '    Dim strNumberOfBeams As String
    '    strNumberOfBeams = InputBox("Enter Number of Beams  ", "Number Of Beams", Str(intNumberOfBeamsDefault))
    '    If strNumberOfBeams <> "" And IsNumeric(strNumberOfBeams) Then
    '        intNumberOfBeamsDefault = Convert.ToInt16(strNumberOfBeams)
    '        If (intNumberOfBeamsDefault < 16) Then intNumberOfBeamsDefault = 16
    '        If (intNumberOfBeamsDefault > 128) Then intNumberOfBeamsDefault = 128
    '        boolSettingsChanged = True
    '    End If
    '    Me.Refresh()
    '    System.Windows.Forms.Application.DoEvents()
    'End Sub

    Private Sub mnuComboBoxBeams_Click(sender As Object, e As EventArgs) Handles mnuComboBoxBeams.TextChanged
        On Error Resume Next
        intNumberOfBeamsDefault = Val(Me.mnuComboBoxBeams.Text)
        boolSettingsChanged = True
        mnuBeams.Text = "Beams           (" & intNumberOfBeamsDefault & ")"
        If mnuComboBoxBeams.Visible Then
            SettingsToolStripMenuItem.HideDropDown()
        End If
        Me.Refresh()
    End Sub

    Private Sub SettingsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SettingsToolStripMenuItem.Click
        On Error Resume Next
        mnuBeams.Text = "Beams           (" & intNumberOfBeamsDefault & ")"
        mnuComboBoxBeams.Text = intNumberOfBeamsDefault
    End Sub

 End Class