﻿
Imports System.Math

Module modCollision
    ' bumper switches are active low
    ' rear = DI2
    ' left front = DI1
    ' right front = DI0

    Public Function ftnCheckForCollision() As Boolean
        Try
            ftnCheckForCollision = False
            If boolCollisionDetectionEnable Then
                If boolCollisionDetected Or (byteCollisionCode <> 7) Then  '  
                    ftnCheckForCollision = True
                ElseIf (boolSimulatedMovement Or Not boolBotConnected) Then
                    ftnCheckForCollision = False
                    byteCollisionCode = 7
                ElseIf (byteCollisionCode_API <> 7) Then ' don't overwrite if set by API
                    byteCollisionCode = byteCollisionCode_API
                    byteCollisionCode_API = 7
                ElseIf boolEnableBumperSwitches_ER1 Then
                    byteCollisionCode = Val(ftnSendCommand("bumper"))  ' should send blank line here but that would reduce loop rate 
                    If (byteCollisionCode = 7) Then strGetDigital &= ftnSendCommand("events") '  
                End If
                If boolEnableEvolutionIR_ER1 Then
                    If CBool(InStr(strMoveResponseForEvolutionIRs, "ir 1")) Then
                        byteCollisionCode = 5 ' Left front
                    ElseIf CBool(InStr(strMoveResponseForEvolutionIRs, "ir 2")) Then
                        byteCollisionCode = 4 ' Front
                    ElseIf CBool(InStr(strMoveResponseForEvolutionIRs, "ir 3")) Then
                        byteCollisionCode = 6 ' Right front
                    End If
                End If

                If (byteCollisionCode <> 7) Then
                    tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpStartingPose, 0.2, tbpTargetPoseGlobal) '  ' assume that Collision was detected / communicated 0.2 seconds after the event  
                    boolCollisionDetected = True
                    tbpBotPose = ftnBotStop(tbpBotPose) ' ISSUE STOP COMMAND
                    ftnCheckForCollision = True
                    frmDebug.WritePose(Now() & ":   Collision - Pose Derived From Dead Reckoning:", tbpBotPose)
                    boolPoseConfirmedAfterCollision = False '
                    Select Case byteCollisionCode
                        Case 4
                            If Not GotABotClass.InvokeRequired Then
                                GotABotClass.StatusDriving.ForeColor = Color.Red
                                subDrawBumperSwitch(tbpBotPose, 0)
                            End If
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED -  Front"
                            frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected -  Front")
                        Case 6
                            If Not GotABotClass.InvokeRequired Then
                                GotABotClass.StatusDriving.ForeColor = Color.Red
                                subDrawBumperSwitch(tbpBotPose, -45)
                            End If
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Right Front"
                            frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected - Right Front")
                        Case 5
                            If Not GotABotClass.InvokeRequired Then
                                GotABotClass.StatusDriving.ForeColor = Color.Red
                                subDrawBumperSwitch(tbpBotPose, 45)
                            End If
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Left Front"
                            frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected - Left Front")
                        Case 3
                            If Not GotABotClass.InvokeRequired Then
                                GotABotClass.StatusDriving.ForeColor = Color.Red
                                subDrawBumperSwitch(tbpBotPose, 180)
                            End If
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED - Rear"
                            frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected - Rear")
                        Case Else
                            If Not GotABotClass.InvokeRequired Then
                                GotABotClass.StatusDriving.ForeColor = Color.Red
                                subDrawBumperSwitch(tbpBotPose, 180)
                                subDrawBumperSwitch(tbpBotPose, 45)
                                subDrawBumperSwitch(tbpBotPose, -45)
                                subDrawBumperSwitch(tbpBotPose, 0)
                            End If
                            strStatusDriving = intDrivingSequenceNumber & ": COLLISION DETECTED "
                            frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Detected ")
                    End Select
                End If
                GotABotClass.subUpdateStatusLine()
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnCheckForCollision")
        End Try
    End Function

    Public boolSlamCollision As Boolean = False
    Public Function ftnCollisionRecovery(ByVal tbpEstimatedPose As typeBotPose) As typeBotPose
        Try
            ftnCollisionRecovery = tbpEstimatedPose
            If Not boolStop Then
                subDoEventsIfMainThread()
                boolCollisionDetectionEnable = False
                frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Collision Recovery Initiated")
                subWait(250)
                Dim boolEnableBumperSwitches_ER1_Temp As Boolean = boolEnableBumperSwitches_ER1
                boolEnableBumperSwitches_ER1 = False
                boolCollisionDetected = False
                ftnSendCommand("play phraseA dough!!")
                Dim intFrequentBumpMultiplier As Integer = ftnFrequentCollisionMultiplier()
                intCollisions += 1
                Dim tbpTargetPose As typeBotPose = tbpEstimatedPose
                Dim sngBackupDistance As Single = Min(sngTenInches, ftnRangerBackupObstacleDistance() - sngOneInch)
                Select Case byteCollisionCode
                    Case 6
                        ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, -90)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery - Right Front"
                        GotABotClass.subUpdateStatusLine()
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 180, sngBackupDistance)
                        ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' back up
                        ftnSendCommand("play phrase 'it jumped in front of me!'")
                        ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery)
                        Dim sngTurnAngle As Single = ftnConvertTo360(intFrequentBumpMultiplier * 25)
                        tbpTargetPose = ftnCollisionRecovery
                        tbpTargetPose.Orientation = ftnConvertTo360(ftnCollisionRecovery.Orientation + sngTurnAngle)
                        ftnCollisionRecovery = ftnBotTurn(ftnCollisionRecovery, False, tbpTargetPose) ' collision on right so turn left
                        ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery)
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 0, sngSixInches)
                        ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' forward
                    Case 5
                        ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, 90)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery - Left Front"
                        GotABotClass.subUpdateStatusLine()
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 180, sngBackupDistance)
                        ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' back up
                        ftnSendCommand("play phrase 'pardon me!'")
                        ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery)
                        Dim sngTurnAngle As Single = ftnConvertTo360(-intFrequentBumpMultiplier * 25)
                        tbpTargetPose = ftnCollisionRecovery
                        tbpTargetPose.Orientation = ftnConvertTo360(ftnCollisionRecovery.Orientation + sngTurnAngle)
                        ftnCollisionRecovery = ftnBotTurn(ftnCollisionRecovery, False, tbpTargetPose)  ' collision on left so turn right
                        ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery)
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 0, sngSixInches)
                        ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' forward
                    Case 4
                        ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, 0)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery -  Front"
                        GotABotClass.subUpdateStatusLine()
                        tbpTargetPose.Location = ftnLocationFromEstimatedPose(ftnCollisionRecovery, 180, sngBackupDistance)
                        ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' back up
                        ftnSendCommand("play phrase 'get out of my way!'")
                    Case 3
                        ftnCollisionRecovery = ftnPoseAfterCollision(tbpEstimatedPose, 180)
                        strStatusDriving = intDrivingSequenceNumber & ": COLLISION Recovery - Rear"
                        GotABotClass.subUpdateStatusLine()
                        strTypeOfMove = "Fwd"
                        tbpTargetPoseGlobal.Location = ftnLocationFromEstimatedPose(tbpBotPose, 0, Min(sngTenInches, ftnObstacleForwardDistance(ftnObstacleVectorTop(ftnCollisionRecovery, strTypeOfMove, tbpTargetPose)) - sngTwoInches))
                        ftnCollisionRecovery = ftnBotFwd(ftnCollisionRecovery, tbpTargetPose) ' go forward
                        ftnSendCommand("play phrase 'it snuck up on me!'")
                    Case Else
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  No Action taken:  Bumper switch no longer registers a collision")
                End Select
                If Not GotABotClass.InvokeRequired Then GotABotClass.StatusDriving.ForeColor = Color.Black
                ftnCollisionRecovery.Location = ftnCheckMapArrayLimits(ftnCollisionRecovery.Location)
                subDrawBot(ftnCollisionRecovery)
                If ftnInWall(ftnCollisionRecovery.Location) Then ftnCollisionRecovery.Location = tbpEstimatedPose.Location
                boolCollisionDetected = False
                byteCollisionCode = 7
                boolCollisionDetectionEnable = True
                boolEnableBumperSwitches_ER1 = boolEnableBumperSwitches_ER1_Temp
            End If
            subDoEventsIfMainThread()
            ftnCollisionRecovery = frmCompass.ftnLocalizeUsingCompass(ftnCollisionRecovery, ftnCollisionRecovery)
            ftnCollisionRecovery = ftnLocalize_Top(ftnCollisionRecovery)
            subDrawBot(ftnCollisionRecovery)
            ftnSendCommand("battery")
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnCollisionRecovery")
        End Try
    End Function

    Private Function ftnPoseAfterCollision(ByVal tbpEstimatedPose As typeBotPose, ByVal sngCollisionAngle As Single) As typeBotPose
        'assume that the bot is off course by a bot quarter diameter - direction determined by which collision sensor was activated
        Try
            subWait(500)  ' wait for compass to update orientation
            If boolVerboseLogFile Then frmDebug.WritePose("Pose at start of Pose correction after collision", tbpEstimatedPose)
            tbpEstimatedPose.OrientationUncertainty += 30
            tbpEstimatedPose.LocationUncertainty.X += sngSixInches / sngGridSize
            tbpEstimatedPose.LocationUncertainty.Y += sngSixInches / sngGridSize
            tbpEstimatedPose = frmCompass.ftnLocalizeUsingCompass(tbpEstimatedPose, tbpEstimatedPose)
            ftnPoseAfterCollision = ftnLocalize_Top(tbpEstimatedPose)
            Dim boolDummy As Boolean = False
            If Not boolSlam Then ftnPoseAfterCollision.Location = ftnLocationFromEstimatedPose(tbpEstimatedPose, sngCollisionAngle, sngBotDiameter / 4)
            ftnPoseAfterCollision = ftnValidatePose(ftnPoseAfterCollision, tbpEstimatedPose, boolDummy)
            If (sngCollisionAngle <> 180) Then ftnPoseAfterCollision.Orientation = ftnConvertTo360(tbpEstimatedPose.Orientation + sngCollisionAngle / 5)
            If boolSlam Then
                subSlamMarkAsMoreOccupied(ftnLocationFromEstimatedPose(ftnPoseAfterCollision, sngCollisionAngle, sngBotDiameter / 4))
                boolSlamCollision = True
            End If
            frmDebug.WritePose("Pose corrected due to collision ", ftnPoseAfterCollision)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnPoseAfterCollision")
        End Try
    End Function



    Function ftnFrequentCollisionMultiplier() As Integer ' Bigger movements if frequent bumps
        If (intLastCollisionSequenceNumber > intDrivingSequenceNumber) Then intLastCollisionSequenceNumber = intDrivingSequenceNumber
        ftnFrequentCollisionMultiplier = 3 - (intDrivingSequenceNumber - intLastCollisionSequenceNumber) \ 2
        If ftnFrequentCollisionMultiplier < 1 Then ftnFrequentCollisionMultiplier = 1
        intLastCollisionSequenceNumber = intDrivingSequenceNumber
    End Function

End Module
