﻿

' Interface to the ER1 

Imports System
Imports System.Math
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports Microsoft.VisualBasic
Imports System.EventArgs


Public Module modIF_ER1_AClient
    Public strER1SendMessage As String = ""
    Public strER1ReceiveMessage As String = ""
    Public evntER1DataWaitingToSend As New ManualResetEvent(False)
    Public boolER1DataWaitingToSend As Boolean = False
    Public evntER1DataSent As New ManualResetEvent(False)
    Public evntER1DataReceived As New ManualResetEvent(False)
    Public evntER1ClientDataPassed As New ManualResetEvent(False)
    Dim intNoResponseCounter As Integer = 0


    Public Function ftnER1_Communicate(ByVal strCommand As String, ByVal strResponse As String, ByVal inttimeOut As Integer) As String
        ftnER1_Communicate = ""
        Try
            If classER1Client.Connected And (Not boolShutDown) Then
                If Not boolBotConnected Then
                    strStatusDriving = "ER1 Not Logged In "
                    GotABotClass.subUpdateStatusLine()
                    ftnLogin()
                ElseIf Not boolShutDown Then
                    If (String.CompareOrdinal(strTypeOfMove, "stop") = 0) Then boolMoveComplete = True
                    ftnSendCommandER1(strCommand)
                    If (strResponse <> "") Then ftnER1_Communicate = ftnWaitForExpectedResponse(strResponse, inttimeOut)
                    If Not boolBotConnected Or CBool(InStr(ftnER1_Communicate, "login")) Then ftnLogin()
                    If boolDebugER1IF Then
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}==== ")
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}====     Sending to Bot:    " & strCommand)
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}====     Received From Bot: " & ftnER1_Communicate)
                        frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}==== ")
                    Else
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}==== ")
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}====     Sending to Bot:    " & strCommand)
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}====     Received From Bot: " & ftnER1_Communicate)
                        frmDebug.subDebugLog(Color.Purple, " }}}}}}}}}}==== ")
                    End If
                End If
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnER1_Communicate")
        End Try
    End Function

    Function ftnLogin() As String
        On Error Resume Next
        boolBotConnected = True
        ftnLogin = ftnER1_Communicate("Login " & strPassword, "OK", 1000)
        boolBotConnected = Not CBool(InStr(ftnLogin, "Login"))
        If boolBotConnected Then
            strStatusDriving = "ER1 Logged In "
            GotABotClass.subUpdateStatusLine()
            ftnER1_Communicate("sense speech off", "OK", 1000)
            ftnER1_Communicate("set collision detection off", "OK", 1000)
            ftnER1_Communicate("set obstacle avoidance off", "OK", 1000)
            ftnER1_Communicate("set linear velocity " & sngBotLinearVelocity, "OK", 1000)
            ftnER1_Communicate("set angular velocity " & sngBotAngularVelocity, "OK", 1000)
            ftnER1_Communicate("set power moving 80", "OK", 1000)
            ftnER1_Communicate("sense objects on", "OK", 1000)
            If boolEnableEvolutionIR_ER1 Then ftnER1_Communicate("ir all threshold " & intEvolution_IR_Threshold, "OK", 1000)
            If boolEnableEvolutionIR_ER1 Then ftnER1_Communicate("ir all flash 7 ", "OK", 1000)
            If boolEnableEvolutionIR_ER1 Then ftnER1_Communicate("sense ir", "OK", 1000)
            ftnLogin = ftnER1_Communicate("sense objects on", "OK", 1000)
        End If
    End Function



    Public Function ftnSendCommandER1(ByVal strCommand As String) As String
        ftnSendCommandER1 = ""
        If classER1Client.Connected And (Not boolShutDown) And Not boolSimulatedMovement Then
            Try
                evntER1ClientDataPassed.Reset()
                strER1SendMessage = strCommand & vbCrLf
                boolER1DataWaitingToSend = True
                evntER1DataWaitingToSend.Set()
            Catch e As Exception
                ftnSendCommandER1 = ""
            End Try
        End If
    End Function


    Dim boolMoveComplete As Boolean = False  ' set if ftnGetER1Response detects " done" or if a "stop" command is sent
    Public strMoveResponseForEvolutionIRs As String = ""  ' used by modCollision for Evolution IRs
    Function ftnWaitForExpectedResponse(ByVal strTextToWaitFor As String, ByVal inttimeOut As Integer) As String  '
        ftnWaitForExpectedResponse = ""
        Try
            If classER1Client.Connected Then
                Dim timeOut As DateTime = Now().AddMilliseconds(inttimeOut)
                Dim intTimeToPoll As Short = Min(150, inttimeOut)
                Dim boolMoveCommand As Boolean = CBool(InStr(strTextToWaitFor, "move done"))
                If boolMoveCommand Then boolMoveComplete = False
                Dim intPriority As Short = Thread.CurrentThread.Priority
                Do
                    ftnWaitForExpectedResponse &= ftnGetER1Response(intTimeToPoll)
                    If boolMoveCommand And Not boolCollisionDetected Then
                        Thread.CurrentThread.Priority = ThreadPriority.Highest
                        boolCollisionDetected = ftnCheckForCollision() ' 
                        Thread.CurrentThread.Priority = intPriority
                        ftnWaitForExpectedResponse &= strGetDigital ' strGetDigital captures text when ftnCheckForCollision is checking the bumper switches
                        If Not boolCollisionDetected Then subUpdateMapDuringMove()
                        If boolEnableEvolutionIR_ER1 Then strMoveResponseForEvolutionIRs = ftnWaitForExpectedResponse
                    End If
                Loop Until ((Now() > timeOut) Or CBool(InStr(ftnWaitForExpectedResponse, strTextToWaitFor)) Or boolShutDown Or _
                            boolMoveCommand And (boolStop Or boolMoveComplete Or boolCollisionDetected Or boolCollisionPredicted))
                If (Now() > timeOut) Then
                    frmDebug.subWriteLogs(Color.Purple, " }}}}}}}}}}  WARNING: Bot Communication Timeout while waiting for response: " & strTextToWaitFor)
                    If boolMoveCommand Then ftnWaitForExpectedResponse &= "com timeout"
                    ftnWaitForExpectedResponse &= ftnGetER1Response(100) ' empty the ER1 message queue
                End If
                If (ftnWaitForExpectedResponse <> "") And Not CBool(InStr(ftnWaitForExpectedResponse, vbCr)) Then _
                    ftnWaitForExpectedResponse &= ftnGetER1Response(10) ' Only partial message received.  Try to get the remainder
                If boolMoveCommand And Not boolCollisionDetected Then
                    If Not CBool(InStr(ftnWaitForExpectedResponse, "OK")) Then _
                        ftnWaitForExpectedResponse &= ftnGetER1Response(10) ' empty the ER1 message queue, otherwise the 'OK' response after 'move done' may confuse the following messages
                End If
            Else
                ftnWaitForExpectedResponse = "com error"
                frmDebug.subWriteLogs(Color.Red, " :  WARNING - Bot not connected")
                strStatusDriving = ":  WARNING - Bot not connected"
                GotABotClass.subUpdateStatusLine()
                'subDoEventsIfMainThread()
                boolBotConnected = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnWaitForExpectedResponse")
        End Try
    End Function




    Function ftnGetER1Response(ByVal inttimeOut As Integer) As String  '
        ftnGetER1Response = ""
        Try  ' this function must be thread safe
            If (inttimeOut > 0) Then evntER1DataReceived.WaitOne(inttimeOut)
            evntER1DataReceived.Reset()
            ftnGetER1Response = strER1ReceiveMessage
            evntER1ClientDataPassed.Set()
            strER1ReceiveMessage = ""
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnGetER1Response")
        End Try
    End Function



    Private Sub subRemoveNonPrintable(ByRef strText As String)
        Dim charArray As Char() = strText.ToCharArray()
        strText = ""
        For Each c As Char In charArray
            Dim [cint] As Integer = Convert.ToInt32(c)
            If [cint] < 127 AndAlso [cint] > 31 Then
                strText = strText & c.ToString()
            End If
        Next
    End Sub




    Public Sub subUpdateMapDuringMove()
        tbpBotPose = ftnLocalizeUsingDeadReckoning(tbpBotPose, 0, tbpTargetPoseGlobal)
        GotABotClass.subRedraw(tbpBotPose)
    End Sub







#Region "ER1Client"

    'TODO - Since we are already in a thread, convert to synchronous client
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    '
    '
    '   adapted from http://msdn.microsoft.com/en-us/library/bew39x2a(v=VS.100).aspx
    '
    '
    '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    Dim boolErrorDetected As Boolean = False


    Public Class classER1Client
        Public Shared evntConnectDone As New ManualResetEvent(False) ' ManualResetEvent instances signal completion.
        Public Shared Connected As Boolean = False


        Public Sub subMain()
            On Error Resume Next
            While Not boolShutDown
                classER1Client.Connected = False
                boolErrorDetected = False
                intNoResponseCounter = 0
                Dim ER1EndPoint As New IPEndPoint(ipRobot_IPAddress, intRobot_Port) ' Create a TCP/IP socket.
                Dim ER1ClientSocket As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, 1500)
                ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.SendTimeout, 1500)
                ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)
                ER1ClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.DontLinger, True)
                If boolER1Selected And Not classER1Client.Connected And Not boolErrorDetected And Not boolShutDown Then 'Connect and initialize
                    Thread.Sleep(100)
                    evntConnectDone.Reset()
                    ER1ClientSocket.BeginConnect(ER1EndPoint, New AsyncCallback(AddressOf subConnectCallback), ER1ClientSocket)
                    'GC.Collect()
                    evntConnectDone.WaitOne(1500)
                    If classER1Client.Connected Then subReceive(ER1ClientSocket)
                End If

                intNoResponseCounter = 0
                While classER1Client.Connected And Not boolErrorDetected And Not boolShutDown And boolER1Selected ' subSend commands 
                    evntER1DataWaitingToSend.WaitOne(1000)
                    evntER1DataWaitingToSend.Reset()
                    If boolER1DataWaitingToSend And Not boolErrorDetected And Not boolShutDown Then
                        boolER1DataWaitingToSend = False
                        subSend(ER1ClientSocket, strER1SendMessage)
                        If (intNoResponseCounter > 24) Then boolErrorDetected = True
                        'GC.Collect()
                    End If
                End While
                subDisconnect(ER1ClientSocket)
            End While
        End Sub 'subMain

        Private Sub subDisconnect(ByRef client As Socket)
            Try
                classER1Client.Connected = False
                intNoResponseCounter = 0
                If (client IsNot Nothing) Then
                    If client.Connected Then
                        client.Shutdown(SocketShutdown.Both)
                        Thread.Sleep(500)
                        client.Disconnect(Not boolShutDown)
                        Thread.Sleep(500)
                    End If
                    client.Dispose()
                End If
                'GC.Collect()
                Thread.Sleep(500)
            Catch ex As Exception
                classER1Client.Connected = False
                boolErrorDetected = True
                Thread.Sleep(500)
            End Try
        End Sub

        Private Shared Sub subConnectCallback(ByVal ar As IAsyncResult)
            Try
                If Not boolErrorDetected And Not boolShutDown And (ar IsNot Nothing) Then
                    Dim client As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the ER1ClientState object.
                    If (client IsNot Nothing) Then
                        If client.Connected And Not boolShutDown Then
                            client.EndConnect(ar) ' Complete the connection.
                            evntConnectDone.Set() ' Signal that the connection has been made.
                        End If
                        classER1Client.Connected = client.Connected
                    End If
                End If
            Catch e As Exception
                boolErrorDetected = True
                classER1Client.Connected = False
            End Try
        End Sub 'subConnectCallback


        Private Shared Sub subReceive(ByVal client As Socket)
            If classER1Client.Connected And Not boolShutDown And Not boolErrorDetected And (client IsNot Nothing) Then
                Try
                    Dim state As New typeSocketClass ' Create the state object
                    state.workSocket = client
                    ' Begin receiving the data from the remote device.
                    client.BeginReceive(state.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), state)
                    'GC.Collect()
                Catch e As Exception
                    boolErrorDetected = True
                End Try
            End If
        End Sub 'subReceive


        Private Shared Sub subReceiveCallback(ByVal ar As IAsyncResult)
            Try
                If classER1Client.Connected And Not boolShutDown And Not boolErrorDetected And (ar IsNot Nothing) Then
                    Dim ER1SocketClassInstance As typeSocketClass = CType(ar.AsyncState, typeSocketClass)
                    Dim ER1ClientSocket As Socket = ER1SocketClassInstance.workSocket
                    Dim bytesRead As Integer = ER1ClientSocket.EndReceive(ar) ' Read data from the client socket.
                    strER1ReceiveMessage = ""
                    If classER1Client.Connected And Not boolErrorDetected And bytesRead > 0 And Not boolShutDown _
                        And (ER1ClientSocket IsNot Nothing) Then ' There  might be more data, so store the data received so far.
                        If (ER1SocketClassInstance.sbReceivedData.Length < (UBound(ER1SocketClassInstance.byteReceiveBuffer) - bytesRead)) Then
                            ER1SocketClassInstance.sbReceivedData.Append(Encoding.ASCII.GetString(ER1SocketClassInstance.byteReceiveBuffer, 0, bytesRead) & " ")
                            ER1SocketClassInstance.sbReceivedData.Append(" ")
                            If (strER1ReceiveMessage.Length + bytesRead) < UBound(ER1SocketClassInstance.byteReceiveBuffer) Then
                                strER1ReceiveMessage &= ER1SocketClassInstance.sbReceivedData.ToString() ' Throws exceptions - out of range
                                ER1SocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                            End If
                        End If
                        If strER1ReceiveMessage.Length > 3 Then
                            If CBool(InStr(strER1ReceiveMessage, vbCr)) Then ' Or CBool(InStr(strER1ReceiveMessage, "OK")) Then
                                ER1SocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                                evntER1DataReceived.Set() 'Signal the subMain thread to continue.
                                evntER1ClientDataPassed.WaitOne(500) ' subWait for subMain thread to get the data
                                evntER1ClientDataPassed.Reset()
                                ER1SocketClassInstance.sbReceivedData.Clear()   'clear the buffer
                            End If
                        End If
                    End If
                    If classER1Client.Connected And Not boolShutDown And Not boolErrorDetected And (ER1ClientSocket IsNot Nothing) Then _
                        ER1ClientSocket.BeginReceive(ER1SocketClassInstance.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), ER1SocketClassInstance)
                Else
                    boolErrorDetected = True
                End If 'If classER1Client.Connected
            Catch ex As Exception
                boolErrorDetected = True
            End Try
        End Sub 'subReadCallback

        Private Sub subSend(ByVal ER1ClientSocket As Socket, ByVal strMessage As String)
            ' Convert the string strMessage to byte strMessage using ASCII encoding.
            Dim bytestrMessage As Byte() = Encoding.ASCII.GetBytes(strMessage)
            ' Begin sending strMessage to ER1.
            Try
                If classER1Client.Connected And Not boolErrorDetected And Not boolShutDown And (ER1ClientSocket IsNot Nothing) Then _
                  ER1ClientSocket.BeginSend(bytestrMessage, 0, bytestrMessage.Length, 0, New AsyncCallback(AddressOf subSendCallback), ER1ClientSocket)
                'GC.Collect()
            Catch ex As Exception
                boolErrorDetected = True
            End Try

            evntER1DataSent.WaitOne(300)
            evntER1DataSent.Reset()
        End Sub 'subSend


        Private Sub subSendCallback(ByVal ar As IAsyncResult)
            Try
                If classER1Client.Connected And Not boolErrorDetected And Not boolShutDown And (ar IsNot Nothing) Then
                    Dim ER1ClientSocket As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the ER1SocketClassInstance object.
                    evntER1DataSent.Set()
                End If
            Catch ex As Exception
                evntER1DataSent.Set()
                boolErrorDetected = True
            End Try
        End Sub 'subSendCallback



    End Class 'ER1ClientServerClass


#End Region




End Module

