﻿'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'
'  Example adapted from http://msdn.microsoft.com/en-us/library/fx6588te.aspx
'

'
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports Microsoft.VisualBasic
Imports System.EventArgs
Imports System.Math

Module modIF_RoboRealm_AClient



    Public strRoboRealmSendMessage As String = ""
    Public strRoboRealmReceiveMessage As String = ""
    Public evntRoboRealmDataWaitingToSend As New ManualResetEvent(False)
    Public boolRoboRealmDataWaitingToSend As Boolean = False
    Public evntRoboRealmDataSent As New ManualResetEvent(False)
    Public evntRoboRealmDataReceived As New ManualResetEvent(False)
    Public evntRoboRealmClientDataPassed As New ManualResetEvent(False)


    Public Sub ControlRRBot(ByVal sngDistance As Single, ByVal strTypeOfMove As String)
        Dim sngMoveTime As Single
        On Error Resume Next

        'ftnSetVariableRR("speed", 10)
        If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
            If (Abs(sngDistance) < sngBotLinearAccelerationDistance) Then
                sngMoveTime = Sqrt(Abs(sngDistance) / ftnCmToMapUnits(sngBotLinearAcceleration)) * 1100
            Else
                sngMoveTime = ((Abs(sngDistance) - 1.4 * ftnCmToMapUnits(sngBotLinearAccelerationDistance)) / ftnCmToMapUnits(sngBotLinearVelocity) + sngBotLinearAccelerationTime) * 1000
            End If
        ElseIf (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
            If (Abs(sngDistance) < sngBotAngularAccelerationDistance) Then
                sngMoveTime = Sqrt(Abs(sngDistance) / sngBotAngularAcceleration) * 1100
            Else
                sngMoveTime = ((Abs(sngDistance) - 1.4 * sngBotAngularAccelerationDistance) / sngBotAngularVelocity + sngBotAngularAccelerationTime) * 1000
            End If
        End If
        'ftnSetVariableRR("intMoveTime", CShort(sngMoveTime))
        ftnSetVariableRR("intDistance", CShort(ftnMapUnitsToInches(sngDistance)))

        If True Then '(ftnGetVariableFromRR("command") = "0") Then   ' RoboRealm is configured to use the 'command' control method
            If (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
                ftnSetVariableRR("command", "turn")
            ElseIf (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                ftnSetVariableRR("command", "move")
            End If
            Dim strTemp As String = " "
            Dim timeOut, TimeNow As DateTime
            subDoEventsIfMainThread()
            TimeNow = Now()
            timeOut = TimeNow.AddMilliseconds(sngMoveTime * 8 + 4000)
            Do
                subDoEventsIfMainThread()
                TimeNow = Now()
            Loop Until ((TimeNow > timeOut) Or (ftnGetVariableFromRR("command") = "0") Or boolStop Or boolCollisionDetected)
            'subEndImageRecognition()
            ftnSetVariableRR("command", "stop")
            ftnSetVariableRR("move", 0)
        Else    '  use the 'move' control method (move for a variable length of time)
            ftnSetVariableRR("command", "move")
            If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                If (sngDistance >= 0) Then
                    ftnSetVariableRR("move", 1)
                Else
                    ftnSetVariableRR("move", 2)
                End If
                subWait(sngMoveTime)  ' NOTE - this does not allow Localizing while moving - Replace with timed loop calling DR and localization?
                ftnSetVariableRR("move", 0)
            ElseIf (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) Then
                If (sngDistance >= 0) Then
                    ftnSetVariableRR("move", 5)
                Else
                    ftnSetVariableRR("move", 6)
                End If
                subWait(sngMoveTime)  ' NOTE - this does not allow Localizing while moving - Replace with timed loop calling DR and localization?
                ftnSetVariableRR("move", 0)
                ftnSetVariableRR("command", "stop")
            End If
        End If
    End Sub



    Public Sub AllowRRToControlBot()
        Dim intMove As Integer
        Dim strResponse As String
        Dim boolRRStopped As Boolean = False
        On Error Resume Next
        boolAllowRRToControlBotIsActive = True
        While boolAllowRoboRealmToControlBot And classRoboRealmClient.Connected And Not boolShutDown
            subDoEventsIfMainThread()
            intMove = Val(ftnGetVariableFromRR("move"))
            If boolER1Selected Then
                Select Case intMove
                    Case 0
                        If (Not boolRRStopped) Then tbpBotPose = modBotMovementControl.ftnBotStop(tbpBotPose)
                        boolRRStopped = True
                    Case 1
                        If boolRRStopped Then
                            boolRRStopped = False
                            ftnER1_Communicate("move 330 inches", "", 0)
                        End If
                    Case 2
                        If boolRRStopped Then
                            boolRRStopped = False
                            ftnER1_Communicate("move -330 inches", "", 0)
                        End If
                    Case 5
                        If boolRRStopped Then
                            boolRRStopped = False
                            ftnER1_Communicate("move 720 degrees", "", 0)
                        End If
                    Case 6
                        If boolRRStopped Then
                            boolRRStopped = False
                            ftnER1_Communicate("move -720 degrees", "", 0)
                        End If
                End Select

                strResponse = ftnSendCommand("position")
                If CBool(InStr(strResponse, "OK")) Then strResponse = strResponse.Replace("OK", "")
                ftnSetVariableRR("position", strResponse)

                ftnSendCommand("battery")
                ftnSetVariableRR("battery", strStatusBotVoltage)
            End If

        End While
        boolAllowRRToControlBotIsActive = False
    End Sub

    Public Function ftnGetVariableFromRR(ByVal strVariable As String) As String
        On Error Resume Next
        Dim strResponse As String = ""
        Dim strCommand As String = "<request><get_variable>XXXX</get_variable></request>"
        strCommand = strCommand.Replace("XXXX", strVariable)

        strResponse = ftnSendCommandRR(strCommand)
        If CBool(InStr(strResponse, "<response><" & strVariable & ">")) Then _
           strResponse = strResponse.Replace("<response><" & strVariable & ">", "")
        If CBool(InStr(strResponse, "</" & strVariable & "></response>")) Then
            ftnGetVariableFromRR = strResponse.Replace("</" & strVariable & "></response>", "")
        Else
            ftnGetVariableFromRR = strResponse
        End If
        'GC.Collect()
    End Function


    Public Function ftnSetVariableRR(ByVal strVariable As String, ByVal strValue As String) As String
        On Error Resume Next
        Dim strResponse As String = ""
        Dim strCommand As String = "<request><set_variable><name>XXXX</name><value>YYYY</value></set_variable></request>"
        strCommand = strCommand.Replace("XXXX", strVariable)
        strCommand = strCommand.Replace("YYYY", strValue)
        strResponse = ftnSendCommandRR(strCommand)
        ftnSetVariableRR = strResponse
        'GC.Collect()
    End Function




    Public Function ftnSendCommandRR(ByVal strCommand As String) As String
        Try
            evntRoboRealmClientDataPassed.Reset()
            strRoboRealmSendMessage = strCommand '& vbCrLf
            boolRoboRealmDataWaitingToSend = True
            evntRoboRealmDataWaitingToSend.Set()
            ftnSendCommandRR = ftnGetTextRR(True)
            'GC.Collect()
        Catch e As Exception
            ftnSendCommandRR = ""
        End Try
    End Function

    Public Function ftnTransmitRR(ByVal strCommand As String, ByVal strResponse As String, ByVal inttimeOut As Integer) As String
        On Error Resume Next
        ftnTransmitRR = ""
        ftnSendCommandRR(strCommand)
        If (strResponse <> "") Then ftnTransmitRR = ftnWaitForExpectedResponseRR(strResponse, inttimeOut)
    End Function

    Public Function ftnWaitForExpectedResponseRR(ByVal strTextToWaitFor As String, ByVal inttimeOut As Integer) As String
        On Error Resume Next
        Dim timeOut As DateTime
        ' not safe if called on Localize While Moving thread System.Windows.Forms.Application.DoEvents()
        timeOut = Now().AddMilliseconds(inttimeOut)
        ftnWaitForExpectedResponseRR = ""
        Do
            ftnWaitForExpectedResponseRR = ftnWaitForExpectedResponseRR & ftnGetTextRR(False)
            ' not safe if called on Localize While Moving thread  System.Windows.Forms.Application.DoEvents()
        Loop Until ((Now() > timeOut) Or CBool(InStr(ftnWaitForExpectedResponseRR, strTextToWaitFor)) Or boolStop)
    End Function

    Public Function ftnGetTextRR(ByVal boolWait As Boolean) As String
        On Error Resume Next
        ftnGetTextRR = ""
        If classRoboRealmClient.Connected Then
            If boolWait Then evntRoboRealmDataReceived.WaitOne(1500, True)
            evntRoboRealmDataReceived.Reset()
            ftnGetTextRR = strRoboRealmReceiveMessage
            evntRoboRealmClientDataPassed.Set()
        End If
    End Function

#Region "RoboRealmClient"

    Dim boolErrorDetected As Boolean = False

    Public Class classRoboRealmClient
        Public Shared evntConnectDone As New ManualResetEvent(False) ' ManualResetEvent instances signal completion.
        Public Shared Connected As Boolean = False



        Public Sub MainRoboRealm()
            Dim bytes() As Byte = New [Byte](1023) {} ' Data byteReceiveBuffer for incoming data.
            Dim ipAddress As IPAddress = ipAddress.Parse("127.0.0.1")
            While Not boolShutDown
                'GC.Collect()
                Dim locaRREndPoint As New IPEndPoint(ipAddress, 6060) ' Create a TCP/IP socket.
                Dim RoboRealmClientSocket As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
                'GC.Collect()
                If (boolRoboRealmBotSelected Or boolAllowRoboRealmToControlBot Or boolEnableLocalRR Or boolEnableAVM) And Not boolShutDown Then
                    boolErrorDetected = False
                    RoboRealmClientSocket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)
                    Try
                        If boolEnableLocalRR And (classRoboRealmClient.Connected = False) And Not boolShutDown Then  'Connect and initialize
                            Thread.Sleep(100)  'subWait(100)
                            RoboRealmClientSocket.BeginConnect(locaRREndPoint, New AsyncCallback(AddressOf subConnectCallback), RoboRealmClientSocket)
                            'GC.Collect()
                            Thread.Sleep(2300)  'subWait(2300)
                            If classRoboRealmClient.Connected Then subReceive(RoboRealmClientSocket)
                        End If

                        While classRoboRealmClient.Connected And (boolRoboRealmBotSelected Or boolAllowRoboRealmToControlBot Or boolEnableLocalRR Or boolEnableAVM) And (Not boolErrorDetected) And Not boolShutDown  ' subSend commands 
                            evntRoboRealmDataWaitingToSend.WaitOne(2000)
                            If boolRoboRealmDataWaitingToSend And Not boolErrorDetected And Not boolShutDown Then
                                boolRoboRealmDataWaitingToSend = False
                                subSend(RoboRealmClientSocket, strRoboRealmSendMessage)
                                evntRoboRealmDataWaitingToSend.Reset()
                                'GC.Collect()
                            End If
                        End While
                        subDisconnect(RoboRealmClientSocket)
                        classRoboRealmClient.Connected = False
                    Catch e As Exception
                        subDisconnect(RoboRealmClientSocket)
                        classRoboRealmClient.Connected = False
                    End Try
                Else
                    subDisconnect(RoboRealmClientSocket)
                    classRoboRealmClient.Connected = False
                End If
                If Not (boolEnableLocalRR Or boolEnableAVM) Then Thread.Sleep(500)
                Thread.Sleep(500)
            End While
        End Sub 'subMain

        Private Sub subDisconnect(ByRef client As Socket)
            Try
                If (client IsNot Nothing) Then
                    client.Shutdown(SocketShutdown.Both)
                    If client.Connected Then
                        Thread.Sleep(500)
                        client.Disconnect(Not boolShutDown)
                        Thread.Sleep(500)
                    End If
                    client.Dispose()
                End If
                Thread.Sleep(500)
                'GC.Collect()
            Catch ex As Exception
                classRoboRealmClient.Connected = False
                boolErrorDetected = True
                Thread.Sleep(500)
            End Try
        End Sub



        Private Shared Sub subConnectCallback(ByVal ar As IAsyncResult)
            Try
                Dim client As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the RoboRealmClientState object.
                If client.Connected And Not boolShutDown Then
                    client.EndConnect(ar)  ' Complete the connection.
                    evntConnectDone.Set() ' Signal that the connection has been made.
                End If
                classRoboRealmClient.Connected = client.Connected
            Catch e As Exception
                boolErrorDetected = True
            End Try
        End Sub 'subConnectCallback


        Private Shared Sub subReceive(ByVal client As Socket)
            If classRoboRealmClient.Connected And Not boolShutDown Then
                Try
                    Dim state As New typeSocketClass ' Create the state object
                    state.workSocket = client
                    'client.ReceiveTimeout = 2000
                    ' Begin receiving the data from the remote device.
                    client.BeginReceive(state.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), state)
                    'GC.Collect()
                Catch e As Exception
                    boolErrorDetected = True
                End Try
            End If
        End Sub 'subReceive


        Private Shared Sub subReceiveCallback(ByVal ar As IAsyncResult)
            Try
                If classRoboRealmClient.Connected And Not boolShutDown Then
                    Dim bytesRead As Integer
                    Dim RoboRealmSocketClassInstance As typeSocketClass = CType(ar.AsyncState, typeSocketClass)  'NEW
                    Dim RoboRealmClientSocket As Socket
                    'RoboRealmSocketClassInstance = CType(ar.AsyncState, typeSocketClass)   'NEW
                    RoboRealmClientSocket = RoboRealmSocketClassInstance.workSocket
                    RoboRealmClientSocket.ReceiveTimeout = 5000
                    RoboRealmClientSocket.SendTimeout = 5000
                    bytesRead = RoboRealmClientSocket.EndReceive(ar) ' Read data from the client socket.
                    If Not boolErrorDetected And bytesRead > 0 And Not boolShutDown Then ' There  might be more data, so store the data received so far.
                        RoboRealmSocketClassInstance.sbReceivedData.Append(Encoding.ASCII.GetString(RoboRealmSocketClassInstance.byteReceiveBuffer, 0, bytesRead))
                        strRoboRealmReceiveMessage = RoboRealmSocketClassInstance.sbReceivedData.ToString() ' Check for CRLF. If it is not there, read more data.
                        If strRoboRealmReceiveMessage.IndexOf("/response>") > -1 Then ' Requested data was supplied by RR
                            RoboRealmSocketClassInstance.sbReceivedData = New StringBuilder("")  'clear the buffer  'Equals(Empty)  'clear the buffer
                            evntRoboRealmDataReceived.Set() 'Signal the subMain thread to continue.
                            evntRoboRealmClientDataPassed.WaitOne(1500) ' subWait for subMain thread to get the data
                            evntRoboRealmDataReceived.Reset()
                            evntRoboRealmClientDataPassed.Reset()
                        Else ' Not all data received. Get more.
                        End If
                    End If
                    If Not boolErrorDetected Then RoboRealmClientSocket.BeginReceive(RoboRealmSocketClassInstance.byteReceiveBuffer, 0, typeSocketClass.BufferSize, 0, New AsyncCallback(AddressOf subReceiveCallback), RoboRealmSocketClassInstance)
                End If
            Catch ex As Exception
                boolErrorDetected = True
            End Try
        End Sub 'subReadCallback

        Private Sub subSend(ByVal RoboRealmClientSocket As Socket, ByVal strMessage As String)
            ' Convert the string strMessage to byte strMessage using ASCII encoding.
            Try
                Dim bytestrMessage As Byte() = Encoding.ASCII.GetBytes(strMessage)
                ' Begin sending strMessage to RoboRealm.
                RoboRealmClientSocket.BeginSend(bytestrMessage, 0, bytestrMessage.Length, 0, New AsyncCallback(AddressOf subSendCallback), RoboRealmClientSocket)
                'GC.Collect()
            Catch ex As Exception
                boolErrorDetected = True
            End Try
            evntRoboRealmDataSent.WaitOne(10000)
            evntRoboRealmDataSent.Reset()
        End Sub 'subSend


        Private Sub subSendCallback(ByVal ar As IAsyncResult)
            Try
                Dim RoboRealmClientSocket As Socket = CType(ar.AsyncState, Socket) ' Retrieve the socket from the RoboRealmSocketClassInstance object.
                evntRoboRealmDataSent.Set()
            Catch ex As Exception
                evntRoboRealmDataSent.Set()
                boolErrorDetected = True
            End Try
        End Sub 'subSendCallback

    End Class 'RoboRealmClientServerClass

#End Region




End Module
