﻿' This module uses visual recognizers to localize the bot while 
' it is moving.

Imports System.Math
Imports System.Threading

Module modLocalizeMovingVisual

    Public Class classLocalizeMovingVisual

        Dim intLocalizationsWhileMoving As Short = 0
        Dim intValidLocalizationsWhileMoving As Short = 0

        Public Sub subLocalizeWhileMovingVisual_Top()
            ' tbpStartingPose
            On Error Resume Next
            Dim strObjectFromLocalizer As String
            subStartImageRecognition()  '
            While Not boolShutDown
                If ftnVisualRecognizerEnabled() Then
                    If boolBotIsMoving And ftnVisualRecognizerEnabled() And boolEnableLocalizationWhileMoving And Not boolStop Then
                        strObjectFromLocalizer = ftnGetNextObject()
                        If (CBool(InStr(strObjectFromLocalizer, "object"))) Then
                            subVisualLocalizeWhileMoving(tbpStartingPose, strObjectFromLocalizer)
                            subStartImageRecognition()  '
                            intLocalizationsWhileMoving += 1
                        End If
                    Else
                        If (intLocalizationsWhileMoving > 0) And (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) And boolDebugLWM Then _
                          frmDebug.subWriteLogs(Color.Black, "        (Localized While Moving " & intLocalizationsWhileMoving & " times.  Valid Results " & intValidLocalizationsWhileMoving & " times.) ")
                        intLocalizationsWhileMoving = 0
                        intValidLocalizationsWhileMoving = 0
                        Thread.Sleep(100)
                        sngFwdOrientation = tbpStartingPose.Orientation
                    End If
                Else
                    Thread.Sleep(1000)
                End If
            End While
        End Sub


        Private Sub subVisualLocalizeWhileMoving(ByVal tbpStartingPose As typeBotPose, ByVal strTxtRecv As String)
            ' updates  tbpStartingPose
            Dim boolValidLocation As Boolean = False
            Dim tirLandMark As typeImageRecognized
            Dim tlmLandMark As typeLandMark
            On Error Resume Next
            tirLandMark = ftnDecodeRecognitionString(strTxtRecv)
            tlmLandMark = ftnGetLandMarkDetails(tirLandMark.Name, tirLandMark.intNumber) ' Find the Land Mark in the database
            If (String.CompareOrdinal(strTypeOfMove, "Turn") = 0) And boolBotIsMoving Then
                ' tbpLocalizedBotPose = ftnFindPoseWhileTurning(tbpStartingPose, tlmLandMark, tirLandMark, boolValidLocation)
            ElseIf (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) And boolBotIsMoving Then
                ftnFindPoseWhileMovingFwd(tbpStartingPose, tlmLandMark, tirLandMark, boolValidLocation)
            End If
            If boolValidLocation Then intValidLocalizationsWhileMoving += 1
        End Sub





        '----------------------------------------------------------------------------------------------
        'Localization While Moving:  Solve for Bot's pose  

        Dim sngFwdOrientation As Single  ' used to keep a floating point representation of the average orientation.  
        '                                  Otherwise, the normal integer representation does not allow fine resolution with the averaging algorithm used  
        Private Function ftnFindPoseWhileMovingFwd(ByVal tbpPose As typeBotPose, ByVal tlmLandMark As typeLandMark, _
                                                ByVal tirLandMark As typeImageRecognized, ByRef boolValidLocation As Boolean) As typeBotPose
            ' Corrects orientation and starting orientation when moving forward or back, returns the current Bot Pose.  
            ' This algorithm is somewhat insensitive to DR vs visual localization correlation.
            On Error Resume Next
            Dim intStartingOrientation As Short = tbpStartingPose.Orientation
            ftnFindPoseWhileMovingFwd = tbpStartingPose
            boolValidLocation = False
            Dim tbpDR As typeBotPose = ftnLocalizeUsingDeadReckoning(tbpPose, constVisualProcessingDelay, tbpTargetPoseGlobal)
            Dim sngDistanceStartToLM As Single = ftnDistanceBetweenLocations(tbpStartingPose.Location, tlmLandMark.LandMarkLocation)
            If (tirLandMark.Range > sngFifteenInches) And (sngDistanceStartToLM > sngTenInches) Then
                Dim sngDistanceStartToBot, sngAngleStartBotLM, sngAngleDestinationStartLM, _
                    sngAngleStartLMBot, sngRelativeAngleBotToLM As Single
                Dim intDeltaX, intDeltaY As Short
                sngAngleStartBotLM = 180 - Abs(ftnConvertTo180(ftnRelativeLandMarkBearing(tirLandMark)))
                If (sngAngleStartBotLM = 0) Or (sngAngleStartBotLM = 180) Or (sngAngleStartBotLM = -180) Then sngAngleStartBotLM += 0.01
                sngAngleDestinationStartLM = (tirLandMark.Range / sngDistanceStartToLM * Sin(ftnDegreeToRadian(sngAngleStartBotLM)))
                If ((sngAngleDestinationStartLM < 0) Or (sngAngleDestinationStartLM > 1)) Then
                    boolValidLocation = False
                    ftnFindPoseWhileMovingFwd = tbpDR
                Else
                    sngAngleDestinationStartLM = ftnRadianToDegree(Asin(sngAngleDestinationStartLM))
                    sngAngleStartLMBot = 180 - sngAngleStartBotLM - sngAngleDestinationStartLM

                    sngDistanceStartToBot = sngDistanceStartToLM / Sin(ftnDegreeToRadian(sngAngleStartBotLM)) * Sin(ftnDegreeToRadian(sngAngleStartLMBot))
                    If (sngDistanceStartToBot > 99999) Then sngDistanceStartToBot = 99999

                    intDeltaX = sngDistanceStartToBot * System.Math.Cos(ftnDegreeToRadian(tbpBotPose.Orientation))
                    intDeltaY = sngDistanceStartToBot * System.Math.Sin(ftnDegreeToRadian(-tbpBotPose.Orientation))
                    ftnFindPoseWhileMovingFwd.Location.X += intDeltaX \ sngGridSize
                    ftnFindPoseWhileMovingFwd.Location.Y += intDeltaY \ sngGridSize
                    ftnFindPoseWhileMovingFwd.Location = ftnCheckMapArrayLimits(ftnFindPoseWhileMovingFwd.Location)

                    sngRelativeAngleBotToLM = ftnRelativeLandMarkBearing(tirLandMark)
                    ftnFindPoseWhileMovingFwd.Orientation = ftnConvertTo360(ftnP1ToP2Angle(ftnFindPoseWhileMovingFwd.Location, tlmLandMark.LandMarkLocation) - sngRelativeAngleBotToLM)
                    If (ftnAnglesWithinUncertainty(intStartingOrientation, ftnFindPoseWhileMovingFwd.Orientation, (tbpStartingPose.OrientationUncertainty + 10)) And _
                        ftnLocationWithinPose(ftnFindPoseWhileMovingFwd.Location, tbpDR) And _
                        ftnLocationWithinLMValidRegion(ftnFindPoseWhileMovingFwd.Location, tlmLandMark) And Not ftnInWall(ftnFindPoseWhileMovingFwd.Location)) Then
                        boolValidLocation = True
                        If ftnOrientationPointsRight(tbpStartingPose.Orientation) Then 'Average the corrected orientation with the original orientation
                            sngFwdOrientation = ftnConvertTo360((ftnConvertTo180(sngFwdOrientation) * 3 + ftnConvertTo180(ftnFindPoseWhileMovingFwd.Orientation)) / 4)
                        Else
                            sngFwdOrientation = ftnConvertTo360((sngFwdOrientation * 3 + ftnFindPoseWhileMovingFwd.Orientation) / 4)
                        End If
                        tbpStartingPose.Orientation = sngFwdOrientation
                        ftnFindPoseWhileMovingFwd.Orientation = tbpStartingPose.Orientation
                    Else
                        boolValidLocation = False
                        ftnFindPoseWhileMovingFwd = tbpDR
                    End If
                End If
            Else
                boolValidLocation = False
                ftnFindPoseWhileMovingFwd = tbpDR
            End If
        End Function


        Dim dblTurnPoseX As Double  ' used to keep a floating point representation of the average location.  
        Dim dblTurnPoseY As Double  ' Otherwise, the normal integer representation does not allow fine resolution with the averaging algorithm used  
        Private Function ftnFindPoseWhileTurning(ByVal tbpPose As typeBotPose, ByVal tlmLandMark As typeLandMark, _
                                                ByVal tirLandMark As typeImageRecognized, ByRef boolValidLocation As Boolean) As typeBotPose
            ' Correct Location when turning, returns the current Bot Pose
            ' THIS FUNCTION DOES NOT WORK WELL - too much visual tear.  
            On Error Resume Next
            Dim boolShowMoreTemp As Boolean = boolShowMore
            ftnFindPoseWhileTurning = ftnLocalizeUsingDeadReckoning(tbpPose, constVisualProcessingDelay, tbpTargetPoseGlobal)
            Dim tbpReferencePose As typeBotPose = ftnFindPoseWhileTurning
            boolValidLocation = False
            Dim intUncertaintyThreshold As Integer = sngBotAngularVelocity * 2
            If intUncertaintyThreshold < 11 Then intUncertaintyThreshold = 11
            If (tirLandMark.Range > ftnInchesToMapUnits(22) And (tbpPose.LocationUncertainty.X * sngGridSize > intUncertaintyThreshold) Or (tbpPose.LocationUncertainty.Y * sngGridSize > intUncertaintyThreshold)) Then
                boolShowMore = False
                Dim sngBottoLMRelativeAngle As Single
                Dim sngRotationTime As Single
                Dim timeMoveCommandSentOld As DateTime = timeMoveCommandSent ' Adjust the variable timeMoveCommandSent to agree with the relative angle and bot angular valocity  ??WHY ??

                sngBottoLMRelativeAngle = ftnRelativeLandMarkBearing(tirLandMark)
                Dim sngBotToLmAngle As Single = ftnP1ToP2Angle(tbpBotPose.Location, tlmLandMark.LandMarkLocation)
                Dim sngAngleTravelled As Single = Abs(ftnAngleDifference(tbpStartingPose.Orientation, sngBotToLmAngle))
                sngAngleTravelled += ftnConvertTo180(sngBottoLMRelativeAngle)

                sngRotationTime = sngAngleTravelled / sngBotAngularVelocity
                timeMoveCommandSent = Now().AddMilliseconds(-sngRotationTime * 1000)

                ftnFindPoseWhileTurning = ftnPoseFromLM(tlmLandMark, tirLandMark, boolValidLocation, ftnFindPoseWhileTurning)
                If boolValidLocation Then ftnFindPoseWhileTurning = ftnValidatePose(ftnFindPoseWhileTurning, tbpReferencePose, boolValidLocation)
                timeMoveCommandSent = timeMoveCommandSentOld
                If boolValidLocation And (intLocalizationsWhileMoving = 1) Then
                    dblTurnPoseX = tbpPose.Location.X
                    dblTurnPoseY = tbpPose.Location.Y
                ElseIf boolValidLocation Then  '  Find an average of the starting location and the location determined during Turning
                    dblTurnPoseX = (tbpStartingPose.Location.X * 11 + ftnFindPoseWhileTurning.Location.X) / 12
                    dblTurnPoseY = (tbpStartingPose.Location.Y * 11 + ftnFindPoseWhileTurning.Location.Y) / 12
                    tbpStartingPose.Location.X = dblTurnPoseX
                    tbpStartingPose.Location.Y = dblTurnPoseY
                    ftnFindPoseWhileTurning.Location = tbpStartingPose.Location
                Else
                    boolValidLocation = False
                End If
            Else
                boolValidLocation = False
            End If
            boolShowMore = boolShowMoreTemp
        End Function



    End Class

End Module
