﻿Imports System.Math


Public Module modLocalizeOdometry
    ' This module is responsible for robot localization through odometry data.

    Public tmcStartingOdometry As typeMapCoordinate

    Public Function ftnLocalizeUsingOdometry(ByVal tbpEstimatedPose As typeBotPose, ByRef tbpStartingPose As typeBotPose) As typeBotPose
        ftnLocalizeUsingOdometry = tbpEstimatedPose
        Try  '
            If (String.CompareOrdinal(strTypeOfMove, "Fwd") = 0) Then
                Dim boolGoodLocalization As Boolean = True
                Dim tmcCurrentOdometry As typeMapCoordinate = ftnGetOdometry_ER1(tbpEstimatedPose, tbpStartingPose)
                Dim trvOdometryVector As typeRangeVector
                trvOdometryVector.sngRange = (ftnDistanceBetweenLocations(tmcStartingOdometry, tmcCurrentOdometry))
                Dim sngDistanceCommanded As Single = ftnDistanceCommanded(tbpStartingPose, tbpTargetPoseGlobal)
                If (sngDistanceCommanded < 0) Then trvOdometryVector.sngRange = -trvOdometryVector.sngRange
                trvOdometryVector.sngAngle = tbpEstimatedPose.Orientation
                ftnLocalizeUsingOdometry.Location = ftnLocationFromLocation(tbpStartingPose.Location, trvOdometryVector.sngAngle, trvOdometryVector.sngRange)
                ftnLocalizeUsingOdometry.Orientation = trvOdometryVector.sngAngle
                If boolDebugOdometry Then frmDebug.WritePose("       Raw Pose Derived From Odometry  ", ftnLocalizeUsingOdometry)
                ftnLocalizeUsingOdometry = ftnValidatePose(ftnLocalizeUsingOdometry, tbpEstimatedPose, boolGoodLocalization)
                tmcStartingOdometry = tmcCurrentOdometry
                If Not boolBotIsMoving Then
                    frmDebug.WritePose(ftnElapsedTime() & "       Pose Derived From Odometry Data ", ftnLocalizeUsingOdometry)
                End If
            Else
                tmcStartingOdometry = ftnGetOdometry_ER1(tbpEstimatedPose, tbpStartingPose)
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnLocalizeUsingOdometry")
        End Try
    End Function


    Function ftnGetOdometry_ER1(ByVal tbpEstimatedPose As typeBotPose, ByVal tbpStartingPose As typeBotPose) As typeMapCoordinate ' returns a relative map coordinate
        Try
            Dim strRecv As String
            Dim strParsedText As String()
            ftnGetOdometry_ER1 = tmcStartingOdometry
            strRecv = ftnSendCommand("position")
            If CBool(InStr(strRecv, "ERROR")) Then strRecv = ftnSendCommand("position")
            If CBool(InStr(strRecv, "ERROR")) Then strRecv = ftnSendCommand("position")
            strParsedText = strRecv.Split(" "c)
            If (UBound(strParsedText) = 2) And CBool(InStr(strRecv, "OK")) And Not CBool(InStr(strRecv, "ERROR")) Then
                ftnGetOdometry_ER1.X = Round(Val(strParsedText(1)) / sngGridSize)
                ftnGetOdometry_ER1.Y = Round(Val(strParsedText(2)) / sngGridSize)
                If boolDebugOdometry Then frmDebug.subWriteLogs(Color.Black, "     ---------   ftnGetOdometry_ER1  : " & ftnGetOdometry_ER1.X & ", " & ftnGetOdometry_ER1.Y)
            Else  ' Error - use dead reckoning instead
                If boolDebugOdometry Then frmDebug.subWriteLogs(Color.Red, Now() & " ftnGetOdometry_ER1 error:  " & strRecv)
                ftnGetOdometry_ER1.X = 9999
                ftnGetOdometry_ER1.Y = 9999
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnGetOdometry_ER1")
        End Try
    End Function


End Module
