﻿Imports System.Math

Module modNavigationArray

    ''''''''''''''''''''''''''''''''''''''''''''''
    '
    '     Map Array Module: 
    '
    '  This module is responsible for:
    '    - converting a map (bmpMap) to a byte array (byteNavigationMap)
    '              0 = free,  255 = occupied
    '    - adding a buffer space around occupied cells 
    '
    ''''''''''''''''''''''''''''''''''''''''''''''
    Public Sub subConvertMapToArray()
        ' Red = 
        ' Green = free / grey /
        ' Blue = 
        ' Occupied = (pixMap.R = 0) And (pixMap.G = 0) And (pixMap.B = 0) 
        Try
            strStatusDriving = "Generating Map Array"
            GotABotClass.subUpdateStatusLine()
            If Not boolSlam Then
                Dim pixMap As Color
                ReDim byteNavigationMap(GotABotClass.imgMap.Width, GotABotClass.imgMap.Height)
                ReDim boolOccupiedCell(GotABotClass.imgMap.Width, GotABotClass.imgMap.Height)
                ReDim boolCompassIsSuspect(GotABotClass.imgMap.Width, GotABotClass.imgMap.Height)
                ReDim byteDistanceFromWallArray(GotABotClass.imgMap.Width, GotABotClass.imgMap.Height)
                For intX As Short = 0 To GotABotClass.imgMap.Width - 1   ' Convert the map image into byteNavigationMap.   0 = free,  255 = occupied, grey = 33-64(?)
                    For intY As Short = 0 To GotABotClass.imgMap.Height - 1
                        pixMap = bmpMap.GetPixel(intX, intY)
                        boolCompassIsSuspect(intX, intY) = (pixMap.R = 255) And (pixMap.G = 216) And (pixMap.B = 176)
                        boolOccupiedCell(intX, intY) = (pixMap.R = 0) And (pixMap.G = 0) And (pixMap.B = 0)
                        If boolCompassIsSuspect(intX, intY) Then
                            byteNavigationMap(intX, intY) = 0
                        Else
                            byteNavigationMap(intX, intY) = 255 - bmpMap.GetPixel(intX, intY).G
                        End If
                    Next intY
                    subDoEventsIfMainThread()  ' Jan2014 - i7 - For Loop = 148 ms with and without doevents
                Next intX
            Else
                For intX As Short = 0 To GotABotClass.imgMap.Width - 1   ' Convert byteSlamRawMapArray into byteNavigationMap.   0 = free,  255 = occupied
                    For intY As Short = 0 To GotABotClass.imgMap.Height - 1
                        If (byteSlamRawMapArray(intX, intY) < 128) Then
                            byteNavigationMap(intX, intY) = 0
                            boolOccupiedCell(intX, intY) = False
                        Else
                            byteNavigationMap(intX, intY) = 255
                            boolOccupiedCell(intX, intY) = True
                        End If
                    Next intY
                    subDoEventsIfMainThread()
                Next intX
            End If
            subGenerateDistanceFromWallArray()
            subAddBufferSpace() ' Jan2014 - i7 =  2.9s
            strStatusDriving = "Map Array Generated "
            GotABotClass.subUpdateStatusLine()
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in subConvertMapToArray")
        End Try
    End Sub

    Public Sub subGenerateDistanceFromWallArray() '  Array used by modLocalize2DScan
        Try
            Dim intX_Min, intX_Max, intY_Min, intY_Max As Short
            Dim intDistanceFromWall As Short
            Dim tmcLocation1, tmcLocation2 As typeMapCoordinate
            Dim byteMaxDistance As Byte = sngOneDotFiveSigma / sngGridSize
            Dim byteMaxDistanceP1 As Byte = byteMaxDistance + 1
            For tmcLocation1.X = 0 To GotABotClass.imgMap.Width - 1 ' Mark edges of walls as Distance = 0
                For tmcLocation1.Y = 0 To GotABotClass.imgMap.Height - 1
                    byteDistanceFromWallArray(tmcLocation1.X, tmcLocation1.Y) = byteMaxDistanceP1
                    If boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y) Then
                        If (tmcLocation1.Y < GotABotClass.imgMap.Height - 1) Then _
                                If (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y + 1)) Then _
                                  byteDistanceFromWallArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        If (tmcLocation1.Y > 0) Then _
                            If (Not boolOccupiedCell(tmcLocation1.X, tmcLocation1.Y - 1)) Then _
                              byteDistanceFromWallArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        If (tmcLocation1.X < GotABotClass.imgMap.Width - 1) Then _
                            If (Not boolOccupiedCell(tmcLocation1.X + 1, tmcLocation1.Y)) Then _
                             byteDistanceFromWallArray(tmcLocation1.X, tmcLocation1.Y) = 0
                        If (tmcLocation1.X > 0) Then _
                            If (Not boolOccupiedCell(tmcLocation1.X - 1, tmcLocation1.Y)) Then _
                             byteDistanceFromWallArray(tmcLocation1.X, tmcLocation1.Y) = 0
                    End If
                Next tmcLocation1.Y
            Next tmcLocation1.X

            For intX As Short = 0 To GotABotClass.imgMap.Width - 1
                For intY As Short = 0 To GotABotClass.imgMap.Height - 1
                    tmcLocation1.X = intX
                    tmcLocation1.Y = intY
                    If (byteDistanceFromWallArray(intX, intY) = 0) Then  ' location is a wall edge.  Populate nearby array with distance from this location.
                        intX_Min = (intX - byteMaxDistance)
                        intX_Max = (intX + byteMaxDistance)
                        intY_Min = (intY - byteMaxDistance)
                        intY_Max = (intY + byteMaxDistance)
                        subCheckMapArrayLimits(intX_Min, intX_Max, intY_Min, intY_Max)
                        For tmcLocation2.X = intX_Min To intX_Max ' left and right neighbors
                            For tmcLocation2.Y = intY_Min To intY_Max ' up and down neighbors
                                intDistanceFromWall = Round(ftnDistanceBetweenLocations(tmcLocation1, tmcLocation2))
                                If (intDistanceFromWall < byteDistanceFromWallArray(tmcLocation2.X, tmcLocation2.Y)) Then
                                    byteDistanceFromWallArray(tmcLocation2.X, tmcLocation2.Y) = intDistanceFromWall
                                End If
                            Next tmcLocation2.Y
                        Next tmcLocation2.X
                    End If
                Next intY
            Next intX
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in subGenerateDistanceFromWallArray")
        End Try
    End Sub


    Public Sub subAddBufferSpace() '  Add a buffer space around all walls and objects so that the robot won't bang into them
        Try
            Dim intX_Min, intX_Max, intY_Min, intY_Max As Short
            Dim intDistanceFromWall As Short
            Dim intDistanceFromWallThreshold As Short = intBufferSpaceMaxSize * sngGridSize
            Dim intBufferSpaceCost As Short
            Dim tmcLocation1, tmcLocation2 As typeMapCoordinate
            intBufferSpaceMaxSize = Round((sngBotRadius + sngSixInches) / sngGridSize) ' buffer space around occupied cells, (1-32)
            If (intBufferSpaceMaxSize > 32) Then intBufferSpaceMaxSize = 32
            If intBufferSpaceMaxSize = 0 Then intBufferSpaceMaxSize = 1
            For intX As Short = 0 To GotABotClass.imgMap.Width - 1
                For intY As Short = 0 To GotABotClass.imgMap.Height - 1
                    tmcLocation1.X = intX
                    tmcLocation1.Y = intY
                    If boolOccupiedCell(intX, intY) Then
                        If (byteDistanceFromWallArray(intX, intY) = 0) Then
                            intX_Min = (intX - intBufferSpaceMaxSize)
                            intX_Max = (intX + intBufferSpaceMaxSize)
                            intY_Min = (intY - intBufferSpaceMaxSize)
                            intY_Max = (intY + intBufferSpaceMaxSize)
                            subCheckMapArrayLimits(intX_Min, intX_Max, intY_Min, intY_Max)
                            For tmcLocation2.X = intX_Min To intX_Max ' left and right neighbors
                                For tmcLocation2.Y = intY_Min To intY_Max ' up and down neighbors
                                    If (Not boolOccupiedCell(tmcLocation2.X, tmcLocation2.Y)) Then
                                        intDistanceFromWall = (ftnDistanceBetweenLocations(tmcLocation1, tmcLocation2))
                                        If (intDistanceFromWall <= intDistanceFromWallThreshold) Then
                                            intBufferSpaceCost = constMaxBufferSpaceCost - ftnMapUnitsToInches(intDistanceFromWall)
                                            If (intBufferSpaceCost < constMinimumBufferSpaceCost) Then intBufferSpaceCost = constMinimumBufferSpaceCost
                                            If (intBufferSpaceCost > byteNavigationMap(tmcLocation2.X, tmcLocation2.Y)) Then _
                                                byteNavigationMap(tmcLocation2.X, tmcLocation2.Y) = intBufferSpaceCost
                                        End If
                                    End If
                                Next tmcLocation2.Y
                            Next tmcLocation2.X
                        End If
                    End If
                Next intY
            Next intX
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in subAddBufferSpace")
        End Try
    End Sub

 
End Module
