﻿Imports System.Net
Imports System.Threading
Imports System.Net.Sockets
Imports System.Text
Imports Microsoft.Kinect
Imports Emgu.CV
Imports Emgu.Util
Imports Emgu.CV.Structure
Imports Emgu.CV.CvEnum



'  TODO Get rid of:
'     GotABotClass.imgMap.Width,Y


Public Module modPublicDeclarations


    Public Structure typeImageCoordinate
        Dim X As Short
        Dim Y As Short
    End Structure


    Public Structure typeMapCoordinate
        Dim X As Short
        Dim Y As Short
    End Structure

    '==============  Trig Lookup  ==================
    Public sngSineLookupTable(3600) As Single
    Public sngCoSineLookupTable(3600) As Single



    '==============  Map  ==================
    Public bmpMap As Bitmap = New Bitmap(1024, 1024)
    Public strUnits As String = "inch"
    Public byteNavigationMap(400, 300) As Byte
    Public byteDistanceFromWallArray(400, 300) As Byte '  used by modLocalize2DScan
    Public boolOccupiedCell(400, 300) As Boolean
    Public boolCompassIsSuspect(400, 300) As Boolean
    Public intBufferSpaceMaxSize As Short
    Public sngGridSize As Single = 1
    Public sngZoom As Single = 1
    Public Const constMaxBufferSpaceCost As Short = 32
    Public Const constMinimumBufferSpaceCost As Short = 2
    Public boolShowMore As Boolean = True



    '==============  Bot   ==================
    Public boolER1Selected As Boolean = True
    Public boolRoboRealmBotSelected As Boolean = False
    Public sngBotDiameter As Single = 17
    Public sngBotRadius As Single = sngBotDiameter / 2
    Public sngCameraOffset As Single = -2
    Public ticCameraResolution As typeImageCoordinate
    Public sngCameraFOV As Single = 42
    Public boolEnableRangerAveraging As Boolean = False
    Public boolEnableBumperSwitches_ER1 As Boolean = True
    Public boolEnableEvolutionIR_ER1 As Boolean = False


    '==============  Map Path   ==================

    Public intPathArray(GotABotClass.imgMap.Width, GotABotClass.imgMap.Height) As UShort  'Long
    Public tmcDestination As typeMapCoordinate
    Public Const constDestinationCost As UShort = 4096
    Public byteNoGoNearWallSpaceThreshold As Byte = (constMaxBufferSpaceCost - ftnMapUnitsToInches(sngBotRadius) - 0.5)
    Public Const constMaxPathCost As UShort = 65535

    '==============  Bot Dead Reckoning  ==================
    Public sngBotLinearVelocity As Single = 20    'cm /second
    Public sngBotLinearVelocityXY As Single = 20    'cm /second
    Public sngBotLinearAcceleration As Single = 70  'cm /second /second 
    Public sngBotLinearAccelerationTime As Single = sngBotLinearVelocity / sngBotLinearAcceleration
    Public sngBotLinearAccelerationDistance As Single = ftnCmToMapUnits(sngBotLinearAcceleration * sngBotLinearAccelerationTime * sngBotLinearAccelerationTime / 2)
    Public sngBotLinearAccelerationTimeXY As Single = sngBotLinearVelocity / sngBotLinearAcceleration
    Public sngBotLinearAccelerationDistanceXY As Single = ftnCmToMapUnits(sngBotLinearAcceleration * sngBotLinearAccelerationTime * sngBotLinearAccelerationTime / 2)

    Public sngBotAngularVelocity As Single = 30 'degrees /second
    Public sngBotAngularAcceleration As Single = 40  'cm /second /second 
    Public sngBotAngularAccelerationTime As Single = sngBotAngularVelocity / sngBotAngularAcceleration
    Public sngBotAngularAccelerationDistance As Single = (sngBotAngularAcceleration * sngBotAngularAccelerationTime * sngBotAngularAccelerationTime / 2)
    Public sngAngularVelocityCorrectionFactor As Single = 0.65   ' The Bot's actual angular velocity may not be exactly as commanded 'Unused

    Public sngBotMovementAccuracy As Single = 0.65


    '==============  Bot IP Address  ==================
    Public ipRobot_IPAddress As IPAddress = IPAddress.Parse("192.168.10.150".Trim)
    Public intRobot_Port As Integer = 9000
    Public intLocalRccPort As Integer = 9200
    Public strPassword As String = "Password"


    '==============  Bot Pose  ==================
    Public Structure typeBotPose
        Dim Location As typeMapCoordinate
        Dim LocationUncertainty As typeMapCoordinate
        Dim Orientation As Short
        Dim OrientationUncertainty As Short
    End Structure
    Public tbpBotPose As typeBotPose



    '==============  Driving Control  ==================
    Public boolStop As Boolean = False
    Public boolPause As Boolean = False
    Public boolSimulatedMovement As Boolean = False
    Public boolDrivingToDestination As Boolean = False
    Public sngMaxTravel As Single = 72
    Public intDrivingSequenceNumber As Short
    Public boolCollisionDetected As Boolean = False
    Public boolPoseConfirmedAfterCollision As Boolean = True '
    Public boolCollisionDetectionEnable As Boolean = True
    Public byteCollisionCode As Byte = 7
    Public byteCollisionCode_API As Byte = 7
    Public intLastCollisionSequenceNumber As Short = 0
    Public strTypeOfMove As String = ""  'TODO:  Enumerate.  STOP. FWD, TURN, XY, STANDBY
    Public boolCollisionPredicted As Boolean = False
    Public boolEnableMidCourseCorrection As Boolean = True
    Public boolEnableXY_Motion As Boolean = False
    '==============  LandMarks  ==================

    Public Structure typeLandMark
        Dim LandMarkName As String
        Dim LandMarkLocation As typeMapCoordinate
        Dim intLandMarkHeight As Short
        Dim LandMarkValidRegion As Rectangle
        Dim LandMarkRecognized As Integer
        Dim LandMarkValid As Integer
    End Structure
    Public tlmLandMarkArray(128) As typeLandMark
    Public tlm2DScanLandMarkArray(128) As typeLandMark

    Public Structure typeImageRecognized
        Dim Name As String
        Dim intNumber As Short  ' Short
        Dim intPixelX As Short
        Dim Range As Single
        Dim sngYRotation As Single
    End Structure

    '==============  SOCKETS  ==================

    Public Class typeSocketClass
        Public workSocket As Socket = Nothing ' Client  socket.
        Public Const BufferSize As Integer = 4096 ' Size of subReceive byteReceiveBuffer.
        Public byteReceiveBuffer(BufferSize) As Byte ' subReceive byteReceiveBuffer
        Public sbReceivedData As New StringBuilder ' Received data string.
    End Class '

    Public Class typeSocketClass_SmallBuffer
        Public workSocket As Socket = Nothing ' Client  socket.
        Public Const BufferSize As Integer = 64 ' Size of subReceive byteReceiveBuffer.
        Public byteReceiveBuffer(BufferSize) As Byte ' subReceive byteReceiveBuffer
        Public sbReceivedData As New StringBuilder ' Received data string.
    End Class '



    '==============  Thread Communications  ==================
    Public strAPIPasswordReceived As String = ""


    '==============  Movement and Localization Control  ==================
    Public boolLocalizationInProgress As Boolean = False
    Public boolEnableLocalizationWhileMoving As Boolean = True
    Public timeMoveCommandSent As DateTime
    Public timeDrivingStarted As DateTime
    Public intCollisions As Short = 0
    Public boolBotIsMoving As Boolean = False
    Public tbpStartingPose As typeBotPose ' used by Dead Reckoning and Localization While Moving
    Public tbpTargetPoseGlobal As typeBotPose

    Public Const constER1FwdHysterises As Short = 1
    Public Const constER1TurnHysterises As Short = 3
    Public Const constMaxTurnsWithLocalization As Short = 2  '  prevents Bot from turning back and forth repeatedly
    Public intMovementsSinceLocalization As Short = 0   ' used to force localization at least once every x moves


    '==============  API Variables  ==================
    Public sngLaptopBatteryPercent As Single = 999
    Public intApiUncertainty As Short = 9999
    Public intApiOrientation As Short = 0

    '==============   Recognizer Variables  ==================
    Public sngStartOfMoveDelay As Single = 0  ' Delay from issuing move command to bot until movement starts
    Public Const constVisualProcessingDelay = 0.9
    Public sngLocalizationTime As Single = 10
    Public boolEnableLocalRCC As Boolean = False
    Public boolEnableLocalRR As Boolean = False
    Public boolEnableBotRCC As Boolean = False
    Public boolEnableYRotation As Boolean = False
    Public boolEnableGotAGlyph As Boolean = True
    Public boolEnableAVM As Boolean = False


    '==============   Range Finder Variables  ==================
    Public intHighestEnabledRangerNumber As Short = 14
    Public boolRangersAreEnabled As Boolean = False
    Public Structure typeRangeFinder
        Dim boolEnable As Boolean
        Dim intOffset As typeMapCoordinate
        Dim intOrientation As Short
        Dim intType As Short
        Dim sngRange As Single
        Dim sngMaxRange As Single
        Dim intCalibrate As Short
    End Structure
    Public trfRangeFinders(128) As typeRangeFinder
    Public intAnalogReading As Integer = 0
    Public Structure typeRangeVector
        Dim sngAngle As Single
        Dim sngRange As Single
    End Structure
    Public Const constIR_MaxRange = 80  'cm
    Public intNumberOfEnabledRangers As Short = 4
    Public intEvolution_IR_Threshold As Integer = 94
    Public intRangeCorrectionFactor(512) As Integer
    Public boolRangeReadingsAreFresh As Boolean = False


    '==============  SLAM Variables  ==================
    Public Const constSlamRecordLength = 20
    Public Structure typeSlamRecords
        Dim trfRangeFinders() As typeRangeFinder
        Dim intCompass As Integer
        Dim tirImageRecognized() As typeImageRecognized
        Dim byteNavigationMap(,) As Byte
        Dim tbpBotPose As typeBotPose
        Dim strdriveInstruction As String
    End Structure
    Public tsrSlamRecords(constSlamRecordLength) As typeSlamRecords
    Public boolSlam As Boolean = False
    Public bmpSlamMap As Bitmap = New Bitmap(1024, 1024)

    '==============  Misc Variables  ==================
    Public boolAllowRoboRealmToControlBot As Boolean = False
    Public boolAllowRRToControlBotIsActive As Boolean = False
    Public boolViewLM As Boolean = True
    Public boolViewDebug As Boolean = True
    Public boolSettingsChanged As Boolean = False
    Public boolMute As Boolean = False
    Public boolShutDown As Boolean = False

    '==============  Communication Status  ==================
    Public boolBotConnected As Boolean = False
    Public boolLocalRCCConnected As Boolean = False
    Public boolRRConnected As Boolean = False
    Public boolSend_Complete As Boolean = True


    '==============   Status Line  ==================
    Public strStatusDriving As String = String.Format("{0, -35}", "Waiting for command:     ")
    Public strStatusCommunications As String = String.Format("{0, -35}", "Coms:     ")
    Public strStatusBotVoltage As String = String.Format("{0, -15}", "   --   ")
    Public strStatusLaptopVoltage As String = String.Format("{0, -20}", "   --   ")
    Public strStatusMouseCoordinates As String = String.Format("{0, -15}", "    x,y    ")
    Public strStatusAPIMessage As String = String.Format("{0, -45}", "API: Not connected          ")
    Public strStatusMapContents As String = String.Format("{0, -15}", "   --   ")


    '==============  Docking  ==================
    Public boolDock As Boolean = False
    Public boolDocked As Boolean = False
    Public tmcDock As typeMapCoordinate
    Public intDockOrientation As Short = 0  '  Orientation of Bot when docked
    Public boolDockBackIn As Boolean = False
    Public intDockTriggerPC As Short = 30
    Public sngDockTriggerBot As Single = 11
    Public sngBotBatteryVoltage As Single = 2000


    '================== Kinect   ========================
    Public K_Sensor As KinectSensor
    Public boolKinectConnected As Boolean = False
    Public ipKinectAddress As IPAddress = IPAddress.Parse("192.168.001.100".Trim)
    Public sngKinectCalCoefficients(128) As Single
    Public sngKinectCalibrate As Single = 1
    Public sngKinectCurveAdjust As Single = 0
    Public tmcAccelerometerDistance As typeMapCoordinate
    Public Const constGotAKinectDelay As Short = 0.3
    Public boolRemoteKinect As Boolean = True
    Public intDefaultElevation As Short = 10
    Public Structure typeFaceCoordinate
        Dim X As Short
        Dim Y As Short
    End Structure
    Public tfcFaceCoordinate(8) As typeFaceCoordinate
    Public Structure typeVector4
        Dim W As Double
        Dim X As Double
        Dim Y As Double
        Dim Z As Double
    End Structure
    Public tv4AccelerometerAverage, tv4AccelerometerDistance, tv4AccelerometerOffset As typeVector4
    Public evntVectorsAreFresh As New AutoResetEvent(False)
    Public strFaceLocationX As String
    Public intAudioAngle As Short
    Public intAudioAngleLatch As Short

    '================== Distances  ========================
    Public sngOneInch As Single = ftnInchesToMapUnits(1)
    Public sngTwoInches As Single = ftnInchesToMapUnits(2)
    Public sngThreeInches As Single = ftnInchesToMapUnits(3)
    Public sngFourInches As Single = ftnInchesToMapUnits(4)
    Public sngFiveInches As Single = ftnInchesToMapUnits(5)
    Public sngSixInches As Single = ftnInchesToMapUnits(6)
    Public sngTenInches As Single = ftnInchesToMapUnits(10)
    Public sngFifteenInches As Single = ftnInchesToMapUnits(15)
    Public sngTwentyFiveInches As Single = ftnInchesToMapUnits(25)
    Public sngfortyInches As Single = ftnInchesToMapUnits(40)
    Public sngSixtyFiveInches As Single = ftnInchesToMapUnits(65)
    Public sngOneSigma As Single = ftnInchesToMapUnits(5)
    Public sngOneDotFiveSigma As Single = 1.5 * sngOneSigma
    Public sngTwoSigma As Single = 2 * sngOneSigma



    '================== Scan Vectors (from Kinect or whatever)   ========================
    Public intNumberOfBeamsDefault As Short = 128
    Public intNumberOfBeams As Short = 128
    Public tmcScanVectorOffset As typeMapCoordinate
    Public trvScanVectors(128) As typeRangeVector
    Public Const intScanVectorsMaxRangeInches As Short = 177
    Public Const intScanVectorsMinRangeInches As Short = 20

    '================== Voice   ========================
    Public strNewsURL As String = "http://www.npr.org/player/v2/mediaPlayer.html?action=1&t=4&islist=false"
    Public strWeatherURL As String = "http://weather.yahooapis.com/forecastrss?w=743&u=c"
    Public boolPCVoice As Boolean = True
    Public boolVoiceCommandEnable As Boolean = True

    '================== Conditional Compilation   ========================
    ' unfortunately #Const declarations are not global - must do a manual search and replace
    Public constCompile2dSpike = False
    Public constCompile2dAccelerometer = False
    Public constCompile2dMoving = False

    '================== Debug   ========================
    Public boolVerboseLogFile As Boolean = False ' Write many extra log messages
    Public boolDebugDrive As Boolean = False   ' Write some extra log messages associated with Driving to Destination
    Public boolDebugLWM As Boolean = False   ' Write some extra log messages associated with Localization While Moving and Obstacle avoidance and Course Correction
    Public boolDebugObstacle As Boolean = False   ' Write some extra log messages associated with Localization While Moving and Obstacle avoidance
    Public boolDebugER1IF As Boolean = False   ' Write some extra log messages associated with ER1 IF communications
    Public boolDebugAPI_IF As Boolean = False   ' Write some extra log messages associated with API communications
    Public boolDebugOdometry As Boolean = False   ' Write some extra log messages associated with Odometry
    Public boolDebugLocalize2D As Boolean = False   ' Write some extra log messages associated with 2D Localization
    Public boolDebugKinect As Boolean = False   ' Write some extra log messages associated with the Kinect
    Public boolDebugDock As Boolean = False    ' Write some extra log messages associated with Docking
    Public boolDebugCompass As Boolean = False
    Public boolDebugPath As Boolean = False
    Public boolDebugCollision As Boolean = False
    Public boolDebugSpeech As Boolean = False

    Public boolLogFileEnable As Boolean = True

    '================== Compass   ========================
    Public intCompassOrientation As Short = 0
    Public intCompassOrientationUncertainty As Integer = 16
    Public intCompassOrientationOffset As Integer = 0
    Public boolCompassAttached As Boolean = False
    Public gravity As Double() = {0, 0, 0}


End Module
