﻿
'Default Imports  

Imports System
Imports System.Deployment
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Xml


Imports System.Speech
Imports System.Speech.Recognition


Module modSpeechRecognition


    '================== Speech Recognition   ========================
    Dim strVoiceCommand As String = ""
    Dim intVoiceNumber As Short = 0



    Public WithEvents reco As New SpeechRecognitionEngine

    Public Sub subStartSpeechRecognition()
        On Error Resume Next
        Dim gram As New Recognition.SrgsGrammar.SrgsDocument
        Dim GotAVoiceRule As New Recognition.SrgsGrammar.SrgsRule("GotAVoice")
        Dim GotAVoiceList As New Recognition.SrgsGrammar.SrgsOneOf("destination", "stop", "right", "left", "pausemode", _
                                                                   "inches", "centimeters", "degrees", _
                                                                   "up", "down", "elevate", "comma", "enter", _
                                                                     "recharge", _
                                                                   "status", "localize", "telltime", _
                                                                   "forecast", _
                                                                   "minus", "one", "two", "to", "too", _
                                                                   "three", "four", "five", "six", "seven", _
                                                                   "eight", "nine", "ten", "zero", _
                                                                   "eleven", "twelve", "thirteen", "fourteen", "fifteen", _
                                                                   "sixteen", "seventeen", "eightteen", "nineteen", "teen", _
                                                                   "twenty", "forty", "fifty", "sixty", _
                                                                   "seventy", "eighty", "ninety", _
                                                                   "hundred", "thousand", "million", _
                                                                   "newscast", "npr", "bbc", "foxnews", _
                                                                   "batchfile", "funny", _
                                                                   "gotabot", _
                                                                   "thankyou", "goodbye", "hello")
        GotAVoiceRule.Add(GotAVoiceList)
        gram.Rules.Add(GotAVoiceRule)
        gram.Root = GotAVoiceRule
        reco.LoadGrammar(New Recognition.Grammar(gram))
        reco.SetInputToDefaultAudioDevice()
        reco.RecognizeAsync(RecognizeMode.Multiple)
        timeOut = Now().AddMonths(1)
    End Sub




    Public Sub subSpeechEnableChange()
        On Error Resume Next
        If GotABotClass.mnuVoiceCommandEnable.Checked Then
            reco.RecognizeAsync(RecognizeMode.Multiple)
        Else
            reco.RecognizeAsyncStop()
        End If
    End Sub

    Dim timeOut As DateTime
    Private Sub reco_SpeechRecognized(ByVal sender As Object, ByVal e As System.Speech.Recognition.RecognitionEventArgs) Handles reco.SpeechRecognized
        On Error Resume Next
        If boolVoiceCommandEnable Then
            If boolDebugSpeech Then frmDebug.subWriteLogs(Color.Black, Now() & " new speech = " & e.Result.Text)
            If (Now() > timeOut) Then
                strVoiceCommand = " "
                timeOut = Now().AddSeconds(15)
                If CBool(InStr(strVoiceCommand, "command")) Then
                    If Not boolMute Then Beep()
                    If Not boolMute Then Beep()
                    If Not boolMute Then Beep()
                End If
            End If
            If (e.Result.Text = "gotabot") Then
                strVoiceCommand = "command "
                intVoiceNumber = 0
                intAudioAngleLatch = intAudioAngle
                timeOut = Now().AddSeconds(7)
                If Not boolMute Then Beep()
            ElseIf CBool(InStr(strVoiceCommand, "command")) Then
                Select Case e.Result.Text
                    Case "status"
                        subVoiceParse("command report")
                    Case "thankyou"
                        subVoiceParse("command thanks")
                    Case "byebye"
                        subVoiceParse("command goodbye")
                    Case "goodbye"
                        subVoiceParse("command goodbye")
                    Case "hello"
                        subVoiceParse("command hello")
                    Case "localize"
                        subVoiceParse("command localize")
                    Case "foxnews"
                        subVoiceAddWord("command ", "fox")
                    Case "npr"
                        subVoiceAddWord("command ", e.Result.Text)
                    Case "bbc"
                        subVoiceAddWord("command ", e.Result.Text)
                    Case "newscast"
                        If (strVoiceCommand = "command ") Then
                            strVoiceCommand &= "news"
                            subVoiceParse(strVoiceCommand)
                        ElseIf (strVoiceCommand = "command fox ") Then
                            strVoiceCommand = "command fox news"
                            subVoiceParse(strVoiceCommand)
                        ElseIf (strVoiceCommand = "command bbc ") Then
                            strVoiceCommand = "command bbc news"
                            subVoiceParse(strVoiceCommand)
                        ElseIf (strVoiceCommand = "command npr ") Then
                            strVoiceCommand = "command npr news"
                            subVoiceParse(strVoiceCommand)
                        Else
                            subVoiceError()
                        End If
                    Case "forecast"
                        subVoiceParse("command forecast")
                    Case "telltime"
                        subVoiceParse("command time")
                    Case "recharge"
                        subVoiceParse("command dock")
                    Case "elevate"
                        timeOut = Now().AddSeconds(15)
                        subVoiceAddWord("command ", e.Result.Text)
                    Case "up"
                        If K_Sensor IsNot Nothing Then
                            If (strVoiceCommand = "command elevate ") Then
                                strVoiceCommand &= e.Result.Text
                                K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() + 5
                            Else
                                subVoiceError()
                            End If
                        End If
                    Case "down"
                        If K_Sensor IsNot Nothing Then
                            If (strVoiceCommand = "command elevate ") Then
                                strVoiceCommand &= e.Result.Text
                                K_Sensor.ElevationAngle() = K_Sensor.ElevationAngle() - 5
                            Else
                                subVoiceError()
                            End If
                        End If
                    Case "batchfile"
                        subVoiceAddWord("command ", "batch")
                    Case "proceed"
                        If CBool(InStr(strVoiceCommand, "command")) And (CBool(InStr(strVoiceCommand, "move")) Or CBool(InStr(strVoiceCommand, "batch"))) Then
                            subVoiceParse(strVoiceCommand)
                        Else
                            subVoiceError()
                        End If
                        If CBool(InStr(strVoiceCommand, "command")) And CBool(InStr(strVoiceCommand, "batch")) Then
                            If (Dir("kbatch" & intVoiceNumber & ".bat") <> "") Then
                                Process.Start("kbatch" & intVoiceNumber & ".bat")
                                ftnSendCommand("play phrase 'batch file started: " & "kbatch" & intVoiceNumber & ".bat.'")
                            Else
                                ftnSendCommand("play phrase 'ERROR.  File not found.'")
                            End If
                        End If
                    Case "funny"
                        subVoiceParse("command funny")
                    Case Else
                        'subAlphabet(e.Result.Text)
                        subNumbers(e.Result.Text)
                        subMovement(e.Result.Text)
                End Select
            End If
            If (strVoiceCommand <> " ") Then strStatusDriving = strVoiceCommand
        End If
    End Sub

    Sub subVoiceAddWord(ByVal strRequired As String, ByVal strRecognized As String)
        If (strVoiceCommand = strRequired) Then
            strVoiceCommand &= strRecognized & " "
        Else
            subVoiceError()
        End If
    End Sub


    Sub subAlphabet(ByVal strCommand As String)
        Select Case strCommand
            Case "b"
                strVoiceCommand &= "b"
            Case "c"
                strVoiceCommand &= "c"
            Case "n"
                strVoiceCommand &= "n"
            Case "p"
                strVoiceCommand &= "p"
            Case "r"
                strVoiceCommand &= "r"
        End Select
    End Sub

    Sub subMovement(ByVal strCommand As String)
        Select Case strCommand
            Case "stop"
                subVoiceParse("command stop")
            Case "pausemode"
                subVoiceParse("command pause")
            Case "right"
                If (strVoiceCommand = "command ") Then
                    strVoiceCommand &= "move -"
                ElseIf (strVoiceCommand = "command move ") Then
                    strVoiceCommand = "command move -45 degrees"
                    subVoiceParse(strVoiceCommand)
                Else
                    subVoiceError()
                End If
            Case "left"
                If (strVoiceCommand = "command ") Then
                    strVoiceCommand &= "move "
                ElseIf (strVoiceCommand = "command move ") Then
                    strVoiceCommand = "command move 45 degrees"
                    subVoiceParse(strVoiceCommand)
                Else
                    subVoiceError()
                End If
            Case "destination"
                timeOut = Now().AddSeconds(15)
                subVoiceAddWord("command ", "move")
            Case "degrees"
                If CBool(InStr(strVoiceCommand, "move")) Or CBool(InStr(strVoiceCommand, "elevate")) Then
                    strVoiceCommand &= " degrees"
                    If K_Sensor IsNot Nothing Then
                        If CBool(InStr(strVoiceCommand, "command elevate")) Then
                            K_Sensor.ElevationAngle() = intVoiceNumber
                        End If
                    End If
                End If
            Case "inches"
                strVoiceCommand &= " i"
                subVoiceParse(strVoiceCommand)
            Case "centimeters"
                strVoiceCommand &= " cm"
                subVoiceParse(strVoiceCommand)
            Case "enter"
                If CBool(InStr(strVoiceCommand, "move")) Then
                    timeOut = Now().AddSeconds(15)
                    strVoiceCommand &= " "
                    intVoiceNumber = 0
                Else
                    subVoiceError()
                End If
            Case "comma"
                If CBool(InStr(strVoiceCommand, "move")) Then
                    timeOut = Now().AddSeconds(15)
                    strVoiceCommand &= " "
                    intVoiceNumber = 0
                Else
                    subVoiceError()
                End If
            Case ","
                If CBool(InStr(strVoiceCommand, "move")) Then
                    timeOut = Now().AddSeconds(15)
                    strVoiceCommand &= " "
                    intVoiceNumber = 0
                Else
                    subVoiceError()
                End If
        End Select
    End Sub


    Dim intLastDigit As Integer = 0
    Sub subNumbers(ByVal strNumber As String)
        If CBool(InStr(strVoiceCommand, "move")) Or CBool(InStr(strVoiceCommand, "elevate")) Or CBool(InStr(strVoiceCommand, "batch")) Then
            Select Case strNumber
                Case "minus"
                    strVoiceCommand &= "-"
                Case "zero"
                    subUpdateVoiceNumber(0)
                Case "one"
                    subUpdateVoiceNumber(1)
                Case "two"
                    subUpdateVoiceNumber(2)
                Case "to"
                    subUpdateVoiceNumber(2)
                Case "too"
                    subUpdateVoiceNumber(2)
                Case "three"
                    subUpdateVoiceNumber(3)
                Case "four"
                    subUpdateVoiceNumber(4)
                Case "five"
                    subUpdateVoiceNumber(5)
                Case "six"
                    subUpdateVoiceNumber(6)
                Case "seven"
                    subUpdateVoiceNumber(7)
                Case "eight"
                    subUpdateVoiceNumber(8)
                Case "nine"
                    subUpdateVoiceNumber(9)
                Case "ten"
                    subUpdateVoiceNumber(10)
                Case "eleven"
                    subUpdateVoiceNumber(11)
                Case "twelve"
                    subUpdateVoiceNumber(12)
                Case "thirteen"
                    subUpdateVoiceNumber(13)
                Case "fourteen"
                    subUpdateVoiceNumber(14)
                Case "fifteen"
                    subUpdateVoiceNumber(15)
                Case "sixteen"
                    subUpdateVoiceNumber(16)
                Case "seventeen"
                    subUpdateVoiceNumber(17)
                Case "eighteen"
                    subUpdateVoiceNumber(18)
                Case "nineteen"
                    subUpdateVoiceNumber(19)
                Case "teen"
                    boolLastDigitWasDecade = True
                    subUpdateVoiceNumber(10)
                    boolLastDigitWasDecade = False
                Case "twenty"
                    subUpdateVoiceNumber(20)
                Case "thirty"
                    subUpdateVoiceNumber(30)
                Case "forty"
                    subUpdateVoiceNumber(40)
                Case "fifty"
                    subUpdateVoiceNumber(50)
                Case "sixty"
                    subUpdateVoiceNumber(60)
                Case "seventy"
                    subUpdateVoiceNumber(70)
                Case "eighty"
                    subUpdateVoiceNumber(80)
                Case "ninety"
                    subUpdateVoiceNumber(90)
                Case "hundred"
                    subUpdateVoiceNumber(100)
                Case "thousand"
                    subUpdateVoiceNumber(1000)
                Case "million"
                    subUpdateVoiceNumber(1000000)
            End Select
        End If
    End Sub

    Dim boolLastDigitWasDecade As Boolean = False
    Sub subUpdateVoiceNumber(ByVal intNumber As Integer)
        subRemoveNumberFrom_strVoiceCommand(ftnDigitsToTrim())
        If (intNumber < 10) Then
            If boolLastDigitWasDecade Then
                intVoiceNumber = intVoiceNumber + intNumber
            Else
                intVoiceNumber = intVoiceNumber * 10 + intNumber
            End If
        ElseIf (intNumber < 100) Then
            If boolLastDigitWasDecade Then
                intVoiceNumber = intVoiceNumber + intNumber
            Else
                intVoiceNumber = intVoiceNumber * 100 + intNumber
            End If
        ElseIf (intNumber = 100) Then
            intVoiceNumber = intVoiceNumber * 100
        ElseIf (intNumber = 1000) Then
            intVoiceNumber = intVoiceNumber * 1000
        ElseIf (intNumber = 1000000) Then
            intVoiceNumber = intVoiceNumber * 1000000
        End If
        intLastDigit = intNumber
        boolLastDigitWasDecade = ((Int(intNumber / 10) * 10) = intNumber) And (intNumber <> 0)
        strVoiceCommand &= " " & intVoiceNumber
    End Sub

    Function ftnDigitsToTrim()
        If (intVoiceNumber < 10) Then
            ftnDigitsToTrim = 1
        ElseIf (intVoiceNumber < 100) Then
            ftnDigitsToTrim = 2
        ElseIf (intVoiceNumber < 1000) Then
            ftnDigitsToTrim = 3
        ElseIf (intVoiceNumber < 10000) Then
            ftnDigitsToTrim = 4
        ElseIf (intVoiceNumber < 100000) Then
            ftnDigitsToTrim = 5
        ElseIf (intVoiceNumber < 1000000) Then
            ftnDigitsToTrim = 6
        Else
            ftnDigitsToTrim = 0
        End If
    End Function

    Sub subRemoveNumberFrom_strVoiceCommand(ByVal intDigitsToRemove As Integer)
        Dim intLastDigitIndex As Integer = strVoiceCommand.Length
        strVoiceCommand = strVoiceCommand.Remove(intLastDigitIndex - intDigitsToRemove)
    End Sub

    Sub subVoiceError()
        strVoiceCommand = ""
        intVoiceNumber = 0
        boolLastDigitWasDecade = False
        timeOut = Now().AddMonths(1)
        If Not boolMute Then Beep()
        If Not boolMute Then Beep()
    End Sub

    Public Sub subTextToSpeech(ByVal strText As String)
        On Error Resume Next
        Dim synth As New Synthesis.SpeechSynthesizer
        synth.SetOutputToDefaultAudioDevice()
        synth.Volume = 100
        synth.Speak(strText)
        synth.Dispose()
    End Sub


End Module

