﻿' This module contains subroutine and functions which are used by multiple modules

Imports System.Drawing.Imaging
Imports System.Drawing
Imports System.Math
Imports System.Threading


Public Module modUtilities

    Public Function ftnConvertTo360(ByVal intAngle As Short) As Short
        While intAngle >= 360
            intAngle -= 360
        End While
        While intAngle < 0
            intAngle += 360
        End While
        ftnConvertTo360 = intAngle
    End Function

    Public Function ftnConvertTo360(ByVal sngAngle As Single) As Single
        While sngAngle >= 360
            sngAngle -= 360
        End While
        While sngAngle < 0
            sngAngle += 360
        End While
        ftnConvertTo360 = sngAngle
    End Function

    Public Function ftnConvertTo360(ByVal dblAngle As Double) As Double
        While dblAngle >= 360
            dblAngle -= 360
        End While
        While dblAngle < 0
            dblAngle += 360
        End While
        ftnConvertTo360 = dblAngle
    End Function

    Public Function ftnConvertTo180(ByVal intAngle As Short) As Short
        While intAngle > 180
            intAngle -= 360
        End While
        While intAngle < -180
            intAngle += 360
        End While
        If intAngle = 360 Then intAngle = 0
        ftnConvertTo180 = intAngle
    End Function

    Public Function ftnConvertTo180(ByVal sngAngle As Single) As Single
        While sngAngle > 180
            sngAngle -= 360
        End While
        While sngAngle < -180
            sngAngle += 360
        End While
        If sngAngle = 360 Then sngAngle = 0
        ftnConvertTo180 = sngAngle
    End Function




    Public Function ftnDistanceBetweenLocations(ByVal tmcLocation1 As typeMapCoordinate, ByVal tmcLocation2 As typeMapCoordinate) As Single
        Dim intDistanceX As Short = tmcLocation2.X - tmcLocation1.X
        Dim intDistanceY As Short = tmcLocation2.Y - tmcLocation1.Y
        ftnDistanceBetweenLocations = Sqrt(intDistanceX * intDistanceX + intDistanceY * intDistanceY) * sngGridSize
    End Function




    Public Function ftnMapUnitsToInches(ByVal sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "inch") = 0 Then
            ftnMapUnitsToInches = sngDistanceInMapUnits
        Else
            ftnMapUnitsToInches = sngDistanceInMapUnits * 0.3937
        End If
    End Function


    Public Function ftnMapUnitsToCm(ByVal sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "cm") = 0 Then
            ftnMapUnitsToCm = sngDistanceInMapUnits
        Else
            ftnMapUnitsToCm = sngDistanceInMapUnits * 2.54
        End If
    End Function


    Public Function ftnInchesToMapUnits(ByVal sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "cm") = 0 Then
            ftnInchesToMapUnits = sngDistanceInMapUnits * 2.54
        Else
            ftnInchesToMapUnits = sngDistanceInMapUnits
        End If
    End Function


    Public Function ftnCmToMapUnits(ByVal sngDistanceInMapUnits As Single) As Single
        If String.CompareOrdinal(strUnits, "cm") = 0 Then
            ftnCmToMapUnits = sngDistanceInMapUnits
        Else
            ftnCmToMapUnits = sngDistanceInMapUnits * 0.3937
        End If
    End Function




    Public Sub subWait(ByVal intMillseconds As Integer)
        On Error Resume Next
        Dim TimeEnd As DateTime
        TimeEnd = Now().AddMilliseconds(intMillseconds)
        Do
            If GotABotClass.InvokeRequired Then
                subDoEventsOnMainThread()
            Else
                subDoEventsIfMainThread()
            End If
        Loop Until Now() > TimeEnd Or boolShutDown
        TimeEnd = Nothing
    End Sub




    Public Sub subCheckMapArrayLimits(ByRef intX_Min As Short, ByRef intX_Max As Short, ByRef intY_Min As Short, ByRef intY_Max As Short)
        If intX_Min < 0 Then intX_Min = 0
        If intX_Max > UBound(byteNavigationMap, 1) Then intX_Max = CShort(UBound(byteNavigationMap, 1))
        If intY_Min < 0 Then intY_Min = 0
        If intY_Max > UBound(byteNavigationMap, 2) Then intY_Max = CShort(UBound(byteNavigationMap, 2))
    End Sub

    Public Sub subCheckMapArrayLimits(ByRef intX As Short, ByRef intY As Short)
        If intY < 0 Then intY = 0
        If intY >= UBound(byteNavigationMap, 2) Then intY = CShort(UBound(byteNavigationMap, 2))
        If intX < 0 Then intX = 0
        If intX >= UBound(byteNavigationMap, 1) Then intX = CShort(UBound(byteNavigationMap, 1))
    End Sub



    Public Function ftnCheckMapArrayLimits(ByVal tmcMapCoordinate As typeMapCoordinate) As typeMapCoordinate
        ftnCheckMapArrayLimits = tmcMapCoordinate
        If ftnCheckMapArrayLimits.Y < 0 Then ftnCheckMapArrayLimits.Y = 0
        If ftnCheckMapArrayLimits.Y >= UBound(byteNavigationMap, 2) Then ftnCheckMapArrayLimits.Y = CShort(UBound(byteNavigationMap, 2))
        If ftnCheckMapArrayLimits.X < 0 Then ftnCheckMapArrayLimits.X = 0
        If ftnCheckMapArrayLimits.X >= UBound(byteNavigationMap, 1) Then ftnCheckMapArrayLimits.X = CShort(UBound(byteNavigationMap, 1))
    End Function


    Public Function ftnGetLocalIPAddress() As String
        ' Author = Sam Malone 
        On Error Resume Next
        Dim h As System.Net.IPHostEntry = System.Net.Dns.GetHostEntry(System.Net.Dns.GetHostName)
        ftnGetLocalIPAddress = CType(h.AddressList.GetValue(0), System.Net.IPAddress).ToString
    End Function

    Public Function ftnAnglesWithinUncertainty(ByVal intAngle1 As Short, ByVal intAngle2 As Short, ByVal intMaxDifference As Short) As Boolean
        Try
            If (Abs(ftnConvertTo180((ftnConvertTo360(intAngle1) - ftnConvertTo360(intAngle2)))) <= intMaxDifference) Then
                ftnAnglesWithinUncertainty = True
            ElseIf (ftnConvertTo180(Convert.ToInt16(Abs(ftnConvertTo180(intAngle1))) - ftnConvertTo180(Convert.ToInt16(intAngle2))) <= intMaxDifference) Then
                ftnAnglesWithinUncertainty = True
            Else
                ftnAnglesWithinUncertainty = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnAnglesWithinUncertainty")
        End Try
    End Function

    Public Function ftnAnglesWithinUncertainty(ByVal sngAngle1 As Single, ByVal sngAngle2 As Single, ByVal sngMaxDifference As Single) As Boolean
        Try
            If (Abs(ftnConvertTo180((ftnConvertTo360(Convert.ToInt16(sngAngle1)) - ftnConvertTo360(Convert.ToInt16(sngAngle2))))) <= sngMaxDifference) Then
                ftnAnglesWithinUncertainty = True
            ElseIf (ftnConvertTo180(Convert.ToInt16(Abs(ftnConvertTo180(sngAngle1))) - ftnConvertTo180(Convert.ToInt16(sngAngle2))) <= sngMaxDifference) Then
                ftnAnglesWithinUncertainty = True
            Else
                ftnAnglesWithinUncertainty = False
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnAnglesWithinUncertainty")
        End Try
    End Function

    Public Function ftnOrientationPointsRight(ByVal intAngle As Short) As Boolean
        intAngle = ftnConvertTo360(intAngle)
        ftnOrientationPointsRight = (intAngle < 90) Or (intAngle > 270)
    End Function

    Public Function ftnOrientationPointsRight(ByVal sngAngle As Single) As Boolean
        sngAngle = ftnConvertTo360(sngAngle)
        ftnOrientationPointsRight = (sngAngle < 90) Or (sngAngle > 270)
    End Function

    Public Function ftnOrientationPointsUp(ByVal sngAngle As Single) As Boolean
        sngAngle = ftnConvertTo180(sngAngle)
        ftnOrientationPointsUp = (sngAngle > 0)
    End Function

    Public Function ftnP1ToP2Angle(ByVal tmcP1 As typeMapCoordinate, ByVal tmcP2 As typeMapCoordinate) As Single
        Try
            If (tmcP1.X = tmcP2.X) Then  ' don't want a divide by zero
                ftnP1ToP2Angle = 90
            Else
                ftnP1ToP2Angle = ftnRadianToDegree(Atan(Abs((tmcP1.Y - tmcP2.Y) / (tmcP1.X - tmcP2.X))))
            End If  ' only valid for quadrant 1
            If (tmcP1.X > tmcP2.X) Then ftnP1ToP2Angle = 180 - ftnP1ToP2Angle
            If (tmcP1.Y < tmcP2.Y) Then ftnP1ToP2Angle = 360 - ftnP1ToP2Angle
            ftnP1ToP2Angle = ftnConvertTo360(ftnP1ToP2Angle + 0.01)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnP1ToP2Angle")
        End Try
    End Function

    Public Function ftnTurnAngle(ByVal tbpCurrentPose As typeBotPose, ByVal tmcNextLocation As typeMapCoordinate) As Single  ' 
        Try
            If ((tbpCurrentPose.Location.X = tmcNextLocation.X) And (tbpCurrentPose.Location.Y = tmcNextLocation.Y)) Then
                ftnTurnAngle = ftnP1ToP2Angle(tbpCurrentPose.Location, ftnLowestValueNeighbor(tbpCurrentPose.Location)) - tbpCurrentPose.Orientation
            Else
                ftnTurnAngle = ftnP1ToP2Angle(tbpCurrentPose.Location, tmcNextLocation) - tbpCurrentPose.Orientation
            End If
            ftnTurnAngle = ftnConvertTo180(ftnTurnAngle)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnTurnAngle")
        End Try
    End Function


    Public Function ftnAngleDifference(ByVal intAngle1 As Short, ByVal intAngle2 As Short) As Short
        ftnAngleDifference = (intAngle1 - intAngle2)
        ftnAngleDifference = ftnConvertTo180(ftnAngleDifference)
    End Function

    Public Function ftnAngleDifference(ByVal sngAngle1 As Single, ByVal sngAngle2 As Single) As Single
        ftnAngleDifference = (sngAngle1 - sngAngle2)
        ftnAngleDifference = ftnConvertTo180(ftnAngleDifference)
    End Function

    Public Function ftnDegreeToRadian(ByVal sngDegress As Single) As Single
        ftnDegreeToRadian = sngDegress * 0.017453
    End Function

    Public Function ftnRadianToDegree(ByVal sngDegress As Single) As Single
        ftnRadianToDegree = sngDegress * 57.29578
    End Function




    Public Function ftnLocationFromLocation(ByVal tmcStartingLocation As typeMapCoordinate, ByVal sngAngle As Single, ByVal sngDistance As Single) As typeMapCoordinate
        Try
            sngDistance = sngDistance / sngGridSize
            ftnLocationFromLocation = tmcStartingLocation
#If False Then
        Dim sngOrientationInRadians As Single = ftnDegreeToRadian(tbpEstimatedPose.Orientation)
        Dim sngAngleRadians = ftnDegreeToRadian(sngAngle)
        ftnLocationFromLocation.X += sngDistance * Math.Cos(sngAngleRadians)
        ftnLocationFromLocation.Y += sngDistance * -Math.Sin(sngAngleRadians)
#Else
            Dim intAngle As Short = ftnConvertTo360(sngAngle) * 10
            ftnLocationFromLocation.X += sngDistance * sngCoSineLookupTable(intAngle)
            ftnLocationFromLocation.Y += sngDistance * -sngSineLookupTable(intAngle)
#End If
            ftnLocationFromLocation = ftnCheckMapArrayLimits(ftnLocationFromLocation)
        Catch ex As Exception
            ftnLocationFromLocation = tmcStartingLocation
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnLocationFromLocation")
            frmDebug.subWriteLogs(Color.Green, " tmcStartingLocation =  " & tmcStartingLocation.X & ",  " & tmcStartingLocation.Y)
            frmDebug.subWriteLogs(Color.Green, " sngDistance = " & sngDistance)
            frmDebug.subWriteLogs(Color.Green, " sngAngle = " & sngAngle)
        End Try
    End Function

    Public Function ftnLocationFromEstimatedPose(ByVal tbpEstimatedPose As typeBotPose, ByVal tmcRelativeOffset As typeMapCoordinate) As typeMapCoordinate
        Try
#If False Then
        Dim sngOrientationInRadians As Single = ftnDegreeToRadian(tbpEstimatedPose.Orientation)
        Dim sngCos As Single = Math.Cos(sngOrientationInRadians) / sngGridSize
        Dim sngSin As Single = Math.Sin(sngOrientationInRadians) / sngGridSize
#Else
            Dim intAngle As Short = ftnConvertTo360(tbpEstimatedPose.Orientation) * 10
            Dim sngCos As Single = sngCoSineLookupTable(intAngle) / sngGridSize
            Dim sngSin As Single = sngSineLookupTable(intAngle) / sngGridSize
#End If
            ftnLocationFromEstimatedPose.X = tbpEstimatedPose.Location.X + Int(tmcRelativeOffset.X * sngCos - tmcRelativeOffset.Y * sngSin)
            ftnLocationFromEstimatedPose.Y = tbpEstimatedPose.Location.Y - Int(tmcRelativeOffset.Y * sngCos - tmcRelativeOffset.X * sngSin)
            ftnLocationFromEstimatedPose = ftnCheckMapArrayLimits(ftnLocationFromEstimatedPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnLocationFromEstimatedPose")
        End Try
    End Function

    Public Function ftnLocationFromEstimatedPose(ByVal tbpEstimatedPose As typeBotPose, ByVal trvRangeVector As typeRangeVector) As typeMapCoordinate
        Try
            Dim sngRange As Single = trvRangeVector.sngRange / sngGridSize
#If True Then
            Dim intAngle As Short = ftnConvertTo360(tbpEstimatedPose.Orientation + trvRangeVector.sngAngle) * 10
            ftnLocationFromEstimatedPose = tbpEstimatedPose.Location
            ftnLocationFromEstimatedPose.X += sngRange * sngCoSineLookupTable(intAngle)
            ftnLocationFromEstimatedPose.Y += sngRange * -sngSineLookupTable(intAngle)
#Else
        Dim sngAbsoluteAngle As Single = ftnConvertTo180(tbpEstimatedPose.Orientation + trvRangeVector.sngAngle)
        Dim sngAbsoluteAngleRadians As Single = ftnDegreeToRadian(sngAbsoluteAngle)
        ftnLocationFromEstimatedPose.X += sngRange * Math.Cos(sngAbsoluteAngleRadians)
        ftnLocationFromEstimatedPose.Y += sngRange * -Math.Sin(sngAbsoluteAngleRadians)
#End If
            ftnLocationFromEstimatedPose = ftnCheckMapArrayLimits(ftnLocationFromEstimatedPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnLocationFromEstimatedPose")
        End Try
    End Function

    Public Function ftnLocationFromEstimatedPose(ByVal tbpEstimatedPose As typeBotPose, ByVal sngRelativeAngle As Single, ByVal sngDistance As Single) As typeMapCoordinate
        Try
#If True Then
            Dim intAngle As Short = ftnConvertTo360(tbpEstimatedPose.Orientation + sngRelativeAngle) * 10
            ftnLocationFromEstimatedPose = tbpEstimatedPose.Location
            ftnLocationFromEstimatedPose.X += sngDistance * sngCoSineLookupTable(intAngle)
            ftnLocationFromEstimatedPose.Y += sngDistance * -sngSineLookupTable(intAngle)
#Else
        Dim sngAbsoluteAngle As Single = ftnConvertTo180(tbpEstimatedPose.Orientation + sngRelativeAngle)
        Dim sngAbsoluteAngleRadians As Single = ftnDegreeToRadian(sngAbsoluteAngle)
        ftnLocationFromEstimatedPose.X += sngDistance * Math.Cos(sngAbsoluteAngleRadians)
        ftnLocationFromEstimatedPose.Y += sngDistance * -Math.Sin(sngAbsoluteAngleRadians)
#End If
            ftnLocationFromEstimatedPose = ftnCheckMapArrayLimits(ftnLocationFromEstimatedPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnLocationFromEstimatedPose")
        End Try
    End Function


    Public Function ftnMapLocationsEqual(ByVal tmcLocation1 As typeMapCoordinate, ByVal tmcLocation2 As typeMapCoordinate) As Boolean
        If ((tmcLocation1.X = tmcLocation2.X) And (tmcLocation1.Y = tmcLocation2.Y)) Then
            ftnMapLocationsEqual = True
        Else
            ftnMapLocationsEqual = False
        End If
    End Function

    Public Function ftnConvertToTMC(ByVal intX As Short, ByVal intY As Short) As typeMapCoordinate
        ftnConvertToTMC.X = intX
        ftnConvertToTMC.Y = intY
    End Function

    Public Function ftnConvertToTMC(ByVal intX As Integer, ByVal intY As Integer) As typeMapCoordinate
        ftnConvertToTMC.X = intX
        ftnConvertToTMC.Y = intY
    End Function


    Public Function ftnGreyToColor(ByVal byteIntensity As Byte) As Color
        ftnGreyToColor = ColorTranslator.FromOle(RGB(byteIntensity, byteIntensity, byteIntensity))
    End Function



    Public Function ftnPoseUncertaintyFactor(ByVal tbpPose As typeBotPose) As Integer
        On Error Resume Next
        If (Int(sngGridSize) = sngGridSize) Then
            ftnPoseUncertaintyFactor = ftnMapUnitsToInches(tbpPose.LocationUncertainty.X + tbpPose.LocationUncertainty.Y) * tbpPose.OrientationUncertainty * Int(sngGridSize)
        Else
            ftnPoseUncertaintyFactor = ftnMapUnitsToInches(((tbpPose.LocationUncertainty.X + tbpPose.LocationUncertainty.Y) * tbpPose.OrientationUncertainty)) * sngGridSize
        End If
    End Function




    Public Function ftnMinPoseUncertainty(ByVal tbpPoseIn As typeBotPose) As typeBotPose
        ftnMinPoseUncertainty = tbpPoseIn
        Try
            If tbpPoseIn.OrientationUncertainty < 10 Then ftnMinPoseUncertainty.OrientationUncertainty = 10
            Dim intMinimumUncertainty As Short = sngTenInches \ sngGridSize
            If tbpPoseIn.LocationUncertainty.Y < intMinimumUncertainty Then ftnMinPoseUncertainty.LocationUncertainty.Y = intMinimumUncertainty
            If tbpPoseIn.LocationUncertainty.X < intMinimumUncertainty Then ftnMinPoseUncertainty.LocationUncertainty.X = intMinimumUncertainty
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnMinPoseUncertainty")
        End Try
    End Function

    Public Function ftnRangeCorrectForHeight(ByVal tlmLandMark As typeLandMark, ByVal tirLandMark As typeImageRecognized) As Single
        On Error Resume Next
        ftnRangeCorrectForHeight = tirLandMark.Range
        If (tlmLandMark.intLandMarkHeight <> 0) Then  '  Correct range due to height difference between camera and LandMark
            ftnRangeCorrectForHeight = Sqrt(tirLandMark.Range * tirLandMark.Range - tlmLandMark.intLandMarkHeight * tlmLandMark.intLandMarkHeight)
        End If
    End Function



    Dim dblAvgPoseX As Double  ' used to keep a floating point representation of the average location.  Otherwise, the normal integer representation does not allow fine resolution with the averaging algorithm used  
    Dim dblAvgPoseY As Double
    Public Function ftnFindAvgPose(ByVal tbpAveragePose As typeBotPose, _
                                   ByVal tbpNewEstimatedPose As typeBotPose, _
                                   ByRef intPosesAveraged As Short) As typeBotPose
        Try
            Dim sngEstimateAccuracyFactor As Single
            sngEstimateAccuracyFactor = (tbpAveragePose.LocationUncertainty.X + tbpAveragePose.LocationUncertainty.Y) / _
                                        (tbpNewEstimatedPose.LocationUncertainty.X + tbpNewEstimatedPose.LocationUncertainty.Y)
            If (sngEstimateAccuracyFactor > 1) Then sngEstimateAccuracyFactor = 1
            intPosesAveraged += 1
            If (intPosesAveraged = 1) Then
                dblAvgPoseX = tbpAveragePose.Location.X
                dblAvgPoseY = tbpAveragePose.Location.Y
            End If
            Dim sngCurrentPoseFactor As Single = 1 + intPosesAveraged - sngEstimateAccuracyFactor
            dblAvgPoseX = (dblAvgPoseX * sngCurrentPoseFactor + tbpNewEstimatedPose.Location.X * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            dblAvgPoseY = (dblAvgPoseY * sngCurrentPoseFactor + tbpNewEstimatedPose.Location.Y * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            ftnFindAvgPose.Location.X = Round(dblAvgPoseX)
            ftnFindAvgPose.Location.Y = Round(dblAvgPoseY)
            ftnFindAvgPose.Location = ftnCheckMapArrayLimits(ftnFindAvgPose.Location)
            If (ftnInWall(ftnFindAvgPose.Location)) Then ftnFindAvgPose.Location = tbpAveragePose.Location

            tbpAveragePose.Orientation = ftnConvertTo360(tbpAveragePose.Orientation)
            tbpNewEstimatedPose.Orientation = ftnConvertTo360(tbpNewEstimatedPose.Orientation)
            If ftnOrientationPointsRight(tbpAveragePose.Orientation) Then
                ftnFindAvgPose.Orientation = ftnConvertTo360((ftnConvertTo180(tbpAveragePose.Orientation) * sngCurrentPoseFactor + ftnConvertTo180(tbpNewEstimatedPose.Orientation) * sngEstimateAccuracyFactor) / (intPosesAveraged + 1))
            Else
                ftnFindAvgPose.Orientation = ftnConvertTo360((tbpAveragePose.Orientation * sngCurrentPoseFactor + ftnConvertTo360(tbpNewEstimatedPose.Orientation) * sngEstimateAccuracyFactor) / (intPosesAveraged + 1))
            End If

            ftnFindAvgPose.OrientationUncertainty = ftnConvertTo360((tbpAveragePose.OrientationUncertainty * sngCurrentPoseFactor + tbpNewEstimatedPose.OrientationUncertainty * sngEstimateAccuracyFactor) / (intPosesAveraged + 1))
            ftnFindAvgPose.LocationUncertainty.X = (tbpAveragePose.LocationUncertainty.X * sngCurrentPoseFactor + tbpNewEstimatedPose.LocationUncertainty.X * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            ftnFindAvgPose.LocationUncertainty.Y = (tbpAveragePose.LocationUncertainty.Y * sngCurrentPoseFactor + tbpNewEstimatedPose.LocationUncertainty.Y * sngEstimateAccuracyFactor) / (intPosesAveraged + 1)
            ftnFindAvgPose = ftnMinPoseUncertainty(ftnFindAvgPose)
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnFindAvgPose")
        End Try
    End Function




    Public Function ftnIsValidIP(ByVal addr As String) As Boolean
        On Error Resume Next
        Dim pattern As String = "^([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(\." & _
        "([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}$" 'create our match pattern
        Dim check As New System.Text.RegularExpressions.Regex(pattern)
        Dim valid As Boolean = False 'boolean variable to hold the status
        If addr = "" Then   'no address provided so return false
            valid = False
        Else
            valid = check.IsMatch(addr, 0) 'address provided so use the IsMatch Method
            If Not valid Then frmDebug.subWriteLogs(Color.Green, " EXCEPTION in invalid IP address")
        End If
        Return valid  'return the results
    End Function

    Public Function ftnVisualRecognizerEnabled() As Boolean
        ftnVisualRecognizerEnabled = boolEnableBotRCC Or boolEnableLocalRCC Or boolEnableLocalRR Or boolEnableGotAGlyph Or boolEnableAVM
    End Function



    Public Sub subFindStartEndAngles(ByVal tbpEstimatedPose As typeBotPose, ByRef intStartAngle As Short, ByRef intEndAngle As Short)
        Try
            If ftnOrientationPointsRight(tbpEstimatedPose.Orientation) Then  ' Calculate the Orientation range to check for valid sightings
                intStartAngle = ftnConvertTo180(tbpEstimatedPose.Orientation - tbpEstimatedPose.OrientationUncertainty)
                intEndAngle = ftnConvertTo180(tbpEstimatedPose.Orientation + tbpEstimatedPose.OrientationUncertainty)
            Else
                intStartAngle = ftnConvertTo360(tbpEstimatedPose.Orientation - tbpEstimatedPose.OrientationUncertainty)
                intEndAngle = ftnConvertTo360(tbpEstimatedPose.Orientation + tbpEstimatedPose.OrientationUncertainty)
            End If
            If (intStartAngle > intEndAngle) And ((intStartAngle - intEndAngle + 1) < tbpEstimatedPose.OrientationUncertainty) Then _
                intStartAngle = intStartAngle - 360
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in subFindStartEndAngles")
        End Try
    End Sub



    Delegate Sub DelegateSubMainThread()

    Public Sub subCheckForPause()
        On Error Resume Next
        If GotABotClass.InvokeRequired And Not boolShutDown Then
            Dim newDelegate As New DelegateSubMainThread(AddressOf subCheckForPause)
            GotABotClass.Invoke(newDelegate)
            Thread.Sleep(50)
        Else
            While boolPause And Not boolStop
                strStatusDriving = " PAUSED"
                GotABotClass.subUpdateStatusLine()
                System.Windows.Forms.Application.DoEvents()
                Thread.Sleep(250)
            End While
            strStatusDriving = " "
        End If
    End Sub



    '-----------------------------------------------------------------------------------------------------------------------------------------

    Dim dx, dy, e2, sx, sy, Err As Short
    Public Function ftnFirstPointOnLine(ByVal tmcStartingPoint As typeMapCoordinate, ByVal tmcEndPoint As typeMapCoordinate) As typeMapCoordinate
        'Bresenham's line algorithm - see http://en.wikipedia.org/wiki/Bresenham%27s_line_algorithm
        ' return the first point on a line defined by tmcStartingPoint and tmcEndPoint
        Try
            ftnFirstPointOnLine = tmcStartingPoint
            dx = Abs(tmcEndPoint.X - tmcStartingPoint.X)
            dy = Abs(tmcEndPoint.Y - tmcStartingPoint.Y)
            If tmcStartingPoint.X < tmcEndPoint.X Then sx = 1 Else sx = -1
            If tmcStartingPoint.Y < tmcEndPoint.Y Then sy = 1 Else sy = -1
            Err = dx - dy

            e2 = 2 * Err
            If e2 > -dy Then
                Err = Err - dy
                ftnFirstPointOnLine.X += sx
            End If
            If e2 < dx Then
                Err = Err + dx
                ftnFirstPointOnLine.Y += sy
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnFirstPointOnLine")
        End Try
    End Function


    Public Function ftnNextPointOnLine(ByVal tmcStartingPoint As typeMapCoordinate, ByVal tmcEndPoint As typeMapCoordinate) As typeMapCoordinate
        'Bresenham's line algorithm - see http://en.wikipedia.org/wiki/Bresenham%27s_line_algorithm
        ' return the next point on a line defined by tmcStartingPoint and tmcEndPoint
        Try
            ftnNextPointOnLine = tmcStartingPoint
            e2 = 2 * Err
            If e2 > -dy Then
                Err = Err - dy
                ftnNextPointOnLine.X += sx
            End If
            If e2 < dx Then
                Err = Err + dx
                ftnNextPointOnLine.Y += sy
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnNextPointOnLine")
        End Try
    End Function







    Public Function ftnRangeVectorVsWallError(ByVal tmcVectorOrigin As typeMapCoordinate, ByVal trvVector As typeRangeVector, _
                                             ByVal boolEndPointModel As Boolean, ByRef boolGreySpace As Boolean) As Short
        '  Returns the distance between where the vector says a wall will be versus where tha map says it should be
        '  NOTE:  boolEndPointModel = does not check for intervening walls
        Dim tmcCheckLocation As typeMapCoordinate
        Dim tmcDestination As typeMapCoordinate = tmcCheckLocation
        Try
            tmcCheckLocation = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, trvVector.sngRange)
            boolGreySpace = ftnGreySpace(tmcCheckLocation)
            ftnRangeVectorVsWallError = byteDistanceFromWallArray(tmcCheckLocation.X, tmcCheckLocation.Y)  ' wall distance vs distance reported
            If Not boolEndPointModel Then  ' Perform Ray Cast to check for intervening walls
#If True Then
                tmcDestination = tmcCheckLocation
                tmcCheckLocation = ftnFirstPointOnLine(tmcVectorOrigin, tmcDestination)
                While (Not ftnMapLocationsEqual(tmcCheckLocation, tmcDestination)) And _
                      Not (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y))
                    tmcCheckLocation = ftnNextPointOnLine(tmcCheckLocation, tmcDestination)
                    tmcCheckLocation = ftnCheckMapArrayLimits(tmcCheckLocation)
                End While
                If (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y)) Then _
                    ftnRangeVectorVsWallError = Min(Round(Abs(ftnDistanceBetweenLocations(tmcVectorOrigin, tmcCheckLocation) - trvVector.sngRange)), sngOneDotFiveSigma) ' wall distance vs distance reported
#Else
            Dim sngDistanceFromVectorOrigin As Short = 0
            While (sngDistanceFromVectorOrigin < trvVector.sngRange) And _
                  Not (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y))
                sngDistanceFromVectorOrigin += sngTwoInches
                tmcCheckLocation = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, sngDistanceFromVectorOrigin)
            End While
            If (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y)) Then
                tmcCheckLocation = ftnLocationFromLocation(tmcVectorOrigin, trvVector.sngAngle, sngDistanceFromVectorOrigin - sngOneInch)
                If (boolOccupiedCell(tmcCheckLocation.X, tmcCheckLocation.Y)) Then sngDistanceFromVectorOrigin -= sngOneInch '  minor correction to account for only checking every two inches in initial Ray Cast
                ftnRangeVectorVsWallError = Min(Round(Abs(sngDistanceFromVectorOrigin - trvVector.sngRange)), sngOneDotFiveSigma)  ' wall distance vs distance reported
            End If
#End If
            End If
        Catch ex As Exception
            ftnRangeVectorVsWallError = sngOneDotFiveSigma
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnRangeVectorVsWallError")
            frmDebug.subWriteLogs(Color.Green, " tmcVectorOrigin =  " & tmcVectorOrigin.X & ",  " & tmcVectorOrigin.Y)
            frmDebug.subWriteLogs(Color.Green, " trvVector = " & trvVector.sngRange & " at " & trvVector.sngAngle & " degrees")
            frmDebug.subWriteLogs(Color.Green, " tmcDestination =  " & tmcDestination.X & ",  " & tmcDestination.Y)
            frmDebug.subWriteLogs(Color.Green, " tmcCheckLocation =  " & tmcCheckLocation.X & ",  " & tmcCheckLocation.Y)
        End Try
    End Function



    Public Function ftnFindXY_Parameters(ByVal tbpEstimatedPose As typeBotPose, ByRef tbpTargetPose As typeBotPose) As typeMapCoordinate
        ' Returns X and Y move distances
        Try
            Dim sngMoveDistanceOrAngle As Single = ftnDistanceBetweenLocations(tbpEstimatedPose.Location, tbpTargetPose.Location)
            Dim intTurnAngle As Single = ftnTurnAngle(tbpEstimatedPose, tbpTargetPose.Location)
            Dim sngAngleOfTurnRadians As Single = ftnDegreeToRadian(intTurnAngle)
            ftnFindXY_Parameters.Y = Abs(sngMoveDistanceOrAngle * Sin(sngAngleOfTurnRadians))  '
            ftnFindXY_Parameters.X = Abs(sngMoveDistanceOrAngle * Cos(sngAngleOfTurnRadians))
            If (sngAngleOfTurnRadians < 0) Then ftnFindXY_Parameters.Y = -ftnFindXY_Parameters.Y
            If (Abs(intTurnAngle) > 90) Then ftnFindXY_Parameters.X = -ftnFindXY_Parameters.X
            If (ftnFindXY_Parameters.X = 0) Then
                tbpTargetPose.Orientation = ftnConvertTo360(tbpEstimatedPose.Orientation + 90)  'CHECK!
            Else
                tbpTargetPose.Orientation = ftnConvertTo360(tbpEstimatedPose.Orientation + ftnRadianToDegree(Atan(ftnFindXY_Parameters.Y / ftnFindXY_Parameters.X)))  'CHECK!
            End If
        Catch ex As Exception
            frmDebug.subWriteLogs(Color.Green, " EXCEPTION in ftnFindXY_Parameters")
        End Try
    End Function

    Public Function ftnDistanceCommanded(ByVal tbpStartingPose As typeBotPose, ByVal tbpTargetPose As typeBotPose) As Single
        ftnDistanceCommanded = ftnDistanceBetweenLocations(tbpStartingPose.Location, tbpTargetPose.Location)
        Dim intTurnAngle As Short = ftnTurnAngle(tbpStartingPose, tbpTargetPose.Location)
        Dim boolBigTurn As Boolean = (Abs(intTurnAngle) > 160)
        If boolBigTurn Then ftnDistanceCommanded = -ftnDistanceCommanded
    End Function



    Public Sub subDoEventsIfMainThread()
        If Not GotABotClass.InvokeRequired Then System.Windows.Forms.Application.DoEvents()
    End Sub




    Public Sub subDoEventsOnMainThread()
        On Error Resume Next
        If GotABotClass.InvokeRequired And Not boolShutDown Then
            Dim newDelegate As New DelegateSubMainThread(AddressOf subDoEventsOnMainThread)
            GotABotClass.Invoke(newDelegate)
            Thread.Sleep(50)
        Else
            System.Windows.Forms.Application.DoEvents()
        End If
    End Sub

    Public Sub subCalculateKinectBeamAngles()
        Dim sngKinectOrientationFactor As Single = 58.5 / 128
        For intBeamNumber As Short = 0 To 127
            trvScanVectors(intBeamNumber).sngAngle = (29.25 - sngKinectOrientationFactor * intBeamNumber)
        Next intBeamNumber
    End Sub

    Public Sub subCalculateKinectCoefficients()
        Dim sngKinectCalibrateCM As Single = sngKinectCalibrate / 10
        Dim sngKinectCurveAdjusted As Single = sngKinectCurveAdjust / 29.25
        For intBeamNumber As Short = 0 To 127
            sngKinectCalCoefficients(intBeamNumber) = sngKinectCalibrateCM * (1 + sngKinectCurveAdjusted * Abs(trvScanVectors(intBeamNumber).sngAngle))
        Next intBeamNumber
    End Sub

End Module
